// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ngCordova','pascalprecht.translate'])

.run(function($ionicPlatform, 
				$window, $state, $ionicHistory, $ionicPopup, $filter, service_mcache, $document, $timeout, $cordovaPushV5, $cordovaGlobalization, _APP_SETTINGS, _SERVER_SETTINGS, $rootScope, service_user, service_review, service_inapppurchase, $translate, service_localstorage,service_capture
				) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
      cordova.plugins.Keyboard.disableScroll(true);
      window.addEventListener('native.keyboardshow', function(){
          $rootScope.$broadcast("native.keyboardshow");
        });
      window.addEventListener('native.keyboardhide', function(){
          $rootScope.$broadcast("native.keyboardhide");
        });

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    
    /* push */
		//var isWebView = ionic.Platform.isWebView();
		 //console.log("currentPlatform"+JSON.stringify(currentPlatform));
		//if(isWebView)
		{	
			 
				$cordovaPushV5.initialize({
					android:{
						senderID: _APP_SETTINGS.gcm_sender_id,
						icon: 'ic_stat_pushicon',
						iconColor: '#6b46e5',
						forceShow: false,// BU UYGULAMADA BUNU false yapıyoz
						sound: true,
						vibrate: true
						 
					}
				}).then(function(push){
					
					$cordovaPushV5.onError();
					$cordovaPushV5.onNotification();
					//console.warn("push "+JSON.stringify(push));
					if(push._handlers.registration.length == 0)
					{
						//console.warn("push register ");
						$cordovaPushV5.register()
						.then(function(reg_id){
							console.warn("push register id "+JSON.stringify(reg_id));
							service_mcache.set(_APP_SETTINGS.gcm_key_name,reg_id,_APP_SETTINGS.cache_max_age);
                            service_user.update({device_id:reg_id })
						},function(err){
							console.warn("push register err "+JSON.stringify(err)); 
						});
					}
				});
				$rootScope.$on('$cordovaPushV5:notificationReceived', function(event, data) {
					//console.warn("push geldi !!! ");
                    var ptype = data.additionalData && data.additionalData.data_message && data.additionalData.data_message.type || data.additionalData && data.additionalData.type || null;
				   if (data.additionalData.foreground === false)
				   {
						// arkaplan push geldi, yani bildirim ikonuna basaraktan app i açtı
                        
                        switch(ptype)
                        {
                            case 'new_offr': 
                                var last_state = service_mcache.get('_SEARCH_PAGE_STATE')||{};
                                last_state.selected_tab = 3;
                                last_state.show_bottom_menu = 1;
                                last_state.new_agreed_count = 1;
                                service_mcache.set('_SEARCH_PAGE_STATE',last_state);
                                $state.go("app.search",{});
                            break;
                            case 'add_offr': 
                                var last_state = service_mcache.get('_SEARCH_PAGE_STATE')||{};
                                last_state.selected_tab = 2;
                                last_state.show_bottom_menu = 1; 
                                service_mcache.set('_SEARCH_PAGE_STATE',last_state);
                                $state.go("app.search",{});
                            break;
                            case 'new_message':
                                 
                                $state.go("app.messages",{});
                                 
                            break;
                            case 'fill_profile':
                                 
                                $state.go("app.profile",{});
                                 
                            break;
                            case 'buy_vip':
                                 
                                $state.go("app.vip",{});
                                 
                            break;
                             case 'new_profile_visitor':
                                 
                                $state.go("app.visitors",{});
                                 
                            break;
                            case 'redirect':
                                service_review.redirect(data.additionalData.app_id || data.additionalData.appId || data.additionalData.data_message.app_id || data.additionalData.data_message.appId); 
                            break;
                        }
                        
                         
				   }
				   else
				   {
					    // ön plan push geldi, yani app açık halde
                        switch(ptype)
                        {
                            case 'new_offr':
                                //
                                if($state.current.name != 'app.search')
                                {
                                    var last_state = service_mcache.get('_SEARCH_PAGE_STATE')||{};
                                    last_state.selected_tab = 3;
                                    last_state.show_bottom_menu = 1;
                                    last_state.new_agreed_count = 1;
                                    service_mcache.set('_SEARCH_PAGE_STATE',last_state);

                                    var confirmPopup = $ionicPopup.confirm({
                                        title: $filter('translate')('new_agreed_offer_notifi'),
                                        template: $filter('translate')('new_agreed_offer_notifi_text'),
                                        cssClass: 'text-center',
                                        cancelText: $filter('translate')('Dismiss'),
                                        okText: $filter('translate')('ShowMe'),
                                        okType: 'button-calm'
                                    });

                                    confirmPopup.then(function(res) {
                                        if(res) {
                                             $state.go("app.search",{obj:{selected_tab: 3, show_bottom_menu:1, new_agreed_count:1}});
                                        } else {
                                             
                                        }
                                    });
                                }
                            break;
                             case 'add_offr': 
                                var last_state = service_mcache.get('_SEARCH_PAGE_STATE')||{};
                                last_state.selected_tab = 2;
                                last_state.show_bottom_menu = 1; 
                                service_mcache.set('_SEARCH_PAGE_STATE',last_state);
                                $state.go("app.search",{});
                            break;
                            case 'new_message':
                                if($state.current.name != 'app.message')
                                {
                                    if(!service_mcache.get("_HIDE_LIVE_NEW_MESSAGE_POPUP"))
                                    {
                                        var confirmPopup = $ionicPopup.confirm({
                                            title: $filter('translate')('new_message_come'),
                                            template: '<img img-loading class="in_popup_image" ng-src="'+_SERVER_SETTINGS.image_cdn_url +'w120h120/'+data.additionalData.data_message.data.sender_id+'">' + data.additionalData.data_message.data.message,
                                            cssClass: 'text-center',
                                            cancelText: $filter('translate')('Dismiss'),
                                            okText: $filter('translate')('ShowMe'),
                                            okType: 'button-calm'
                                        });

                                        confirmPopup.then(function(res) {
                                            if(res) {
                                                $state.go("app.messages",{});
                                            } else {
                                                
                                                var confirmPopup2 = $ionicPopup.confirm({
                                                    title: $filter('translate')('WantToSeeThisNextTime'),
                                                    template: $filter('translate')('WantToSeeThisNextTimeText'),
                                                    cssClass: 'text-center',
                                                    cancelText: $filter('translate')('NoHide'),
                                                    okText: $filter('translate')('YesShow'),
                                                    okType: 'button-calm'
                                                });

                                                confirmPopup2.then(function(res) {
                                                    if(res) {
                                                        
                                                    } else {
                                                        service_mcache.set("_HIDE_LIVE_NEW_MESSAGE_POPUP",true);
                                                    }
                                                });
                                            }
                                        });
                                    }
                                }
                            break;
                            case 'fill_profile':
                                  
                                if($state.current.name != 'app.profile')
                                {
                                     
                                        var confirmPopup = $ionicPopup.confirm({
                                            title: $filter('translate')('edit_profile_title'),
                                            template:  data.message,
                                            cssClass: 'text-center',
                                            cancelText: $filter('translate')('Later'),
                                            okText: $filter('translate')('GoProfile'),
                                            okType: 'button-calm'
                                        });

                                        confirmPopup.then(function(res) {
                                            if(res) {
                                                $state.go("app.profile",{});
                                            } else {
                                                 
                                            }
                                        });
                                     
                                }
                                 
                            break;
                            case 'buy_vip':
                                  
                                if($state.current.name != 'app.vip')
                                {
                                     
                                        var confirmPopup = $ionicPopup.confirm({
                                            title: $filter('translate')('buy_vip_now'),
                                            template:  data.message,
                                            cssClass: 'text-center',
                                            cancelText: $filter('translate')('Later'),
                                            okText: $filter('translate')('GoVIP'),
                                            okType: 'button-calm'
                                        });

                                        confirmPopup.then(function(res) {
                                            if(res) {
                                                $state.go("app.vip",{});
                                            } else {
                                                 
                                            }
                                        });
                                     
                                }
                                 
                            break;
                            case 'new_profile_visitor':
                                 
                                
                                if($state.current.name != 'app.vip')
                                {
                                     
                                        var confirmPopup = $ionicPopup.confirm({
                                            title: $filter('translate')('new_profile_visitor'),
                                            template:  data.message,
                                            cssClass: 'text-center',
                                            cancelText: $filter('translate')('Later'),
                                            okText: $filter('translate')('SeeVisitors'),
                                            okType: 'button-calm'
                                        });

                                        confirmPopup.then(function(res) {
                                            if(res) {
                                                $state.go("app.visitors",{});
                                            } else {
                                                 
                                            }
                                        });
                                     
                                }
                                 
                            break;
                            case 'redirect':
                                service_review.redirect(data.additionalData.app_id || data.additionalData.appId || data.additionalData.data_message.app_id || data.additionalData.data_message.appId); 
                            break;
                        }
				   }
                   console.error("PUSH GELDIIII "+window.device.uuid,JSON.stringify(data))

                   $rootScope.$broadcast('onPushNotification',data);// !!!<---

                   
					/*$cordovaPushV5.finish().then(function (result) {
						// OK finished - works only with the dev-next version of pushV5.js in ngCordova as of February 8, 2016
					}, function (err) {
						// handle error
					});*/
						//console.warn("$cordovaPushV5:notificationReceived"+JSON.stringify(data));
					  
				   
				});
				$rootScope.$on('$cordovaPushV5:errorOccurred', function(event, error) {
					// handle error
					//console.warn("$cordovaPushV5:errorOccurred"+JSON.stringify(error));
				});
			 
		}
		/*push*/
		$cordovaGlobalization.getPreferredLanguage()
		.then(function(language){
			//var lang = language.value.substr(0,2).toLowerCase()
			//$translate.use(lang);
			
			var country_code = language.value.split("-")[1].toLowerCase();
			service_mcache.set("_DEVICE_COUNTRY_CODE",country_code);
		
		});

		window._APP_DEFAULT_LANGUAGE = service_mcache.get("_APP_DEFAULT_LANGUAGE");
		if(window._APP_DEFAULT_LANGUAGE)
		$translate.use(window._APP_DEFAULT_LANGUAGE);
		
		var unique_device_hash = window.device.uuid;
		service_mcache.set("_DEVICE_UUID",unique_device_hash+"-"+_APP_SETTINGS.server_app_id, _APP_SETTINGS.cache_max_age);
        if(service_user.check() == false)
        {
            service_user.register();
        }
        else
        {
            service_inapppurchase.onlogin();
        }

        service_user.check_version();

        
  });
  
	window.onResumeEvents = [];
    window.onPauseEvents = [];
	  $ionicPlatform.on('resume', function(){
		 
		 for(var e in window.onResumeEvents)
		 {
			window.onResumeEvents[e]();
			window.onResumeEvents.splice(e,1);
		 }
		 console.log("resume fired");
	  });
	  
	  $ionicPlatform.on('offline',function(){
		console.log("offline fired");
	  });
	  $ionicPlatform.on('online',function(){
		console.log("online fired");
	  });
	  
	  $ionicPlatform.on('pause',function(){
         for(var e in window.onPauseEvents)
		 {
			window.onPauseEvents[e]();
			window.onPauseEvents.splice(e,1);
		 }
		console.log("pause fired");
		 
	  });
  
})

.config(function($stateProvider, $urlRouterProvider,  $translateProvider, $httpProvider, $compileProvider, $ionicConfigProvider, $logProvider) {

	$httpProvider.defaults.timeout = 5000;
	$compileProvider.debugInfoEnabled(false);
	$ionicConfigProvider.views.maxCache(0);
	$logProvider.debugEnabled(false);
	
  $stateProvider

    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'menuCtrl'
  })

  .state('app.search', {
    url: '/search',
     cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/search.html',
        controller: 'searchCtrl'
      }
    },
    params: {
        obj: null
    }
  })

  .state('app.profile', {
      url: '/profile',
      cache: false,
      views: {
        'menuContent': {
          templateUrl: 'templates/profile.html',
           controller: 'profileCtrl'
        }
      }
    })
    .state('app.visitors', {
      url: '/visitors',
       
      views: {
        'menuContent': {
          templateUrl: 'templates/visitors.html',
           controller: 'visitorsCtrl'
        }
      }
    })
    
    .state('app.messages', {
      url: '/messages',
      cache: false,
      views: {
        'menuContent': {
          templateUrl: 'templates/messages.html',
          controller: 'messagesCtrl'
        }
      }
    })
    .state('app.message', {
      url: '/messages/:cid',
      views: {
        'menuContent': {
          templateUrl: 'templates/message.html',
          controller: 'messageCtrl'
        }
      }
    })
    .state('app.message_start', {
      url: '/messages/start/:targer_user_id',
      views: {
        'menuContent': {
          templateUrl: 'templates/message_start.html',
          controller: 'messageStartCtrl'
        }
      }
    })
    .state('app.settings', {
      url: '/settings',
      views: {
        'menuContent': {
          templateUrl: 'templates/settings.html',
          controller: 'settingsCtrl'
        }
      }
    })
    .state('app.vip', {
      url: '/vip',
      views: {
        'menuContent': {
          templateUrl: 'templates/vip.html',
          controller: 'vipCtrl'
        }
      }
    })

  .state('app.user', {
    url: '/user/:user_id',
    views: {
      'menuContent': {
        templateUrl: 'templates/user.html',
        controller: 'userCtrl'
      }
    }
  })
  .state('app.agree', {
    url: '/agree/:agree_id',
    views: {
      'menuContent': {
        templateUrl: 'templates/agree.html',
        controller: 'agreeCtrl'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/search');
  
  
  var langs = {"en" : "English",
				"tr" : "Türkçe", 
				"ar": "عربى",
                "bn":"বাঙালি",// bengalce
                "bg":"български",//bulgarca
                "de":"Deutsche", // 
                "el":"Ελληνικά",
                "es":"Español",
                "fr":"Français",
                "hi":"हिंदी",// hindi
                "id":"Indonesia",
                "it":"Italiano",
                "ja":"日本語",
                "ka":"ქართული",// gürcü
                "pt":"Português",
                "ru":"русский",
                "sv":"Svenska",
                "uk":"український"
				};
	window.langs = langs;
	var files = [];
	for(var lcode in langs)
	{
		files.push({
			prefix: 'langs/',
			key: lcode,
			suffix: '.json'
		});
	}
	$translateProvider.useStaticFilesLoader({ files: files});
	
    
    var prefered = navigator && navigator.language  ? navigator.language.split("-")[0].toLowerCase() : 'en';
    if(window.localStorage["theAppSpecCache._APP_DEFAULT_LANGUAGE"]) prefered = JSON.parse(window.localStorage["theAppSpecCache._APP_DEFAULT_LANGUAGE"]).data;

    //alert(prefered);
    
    $translateProvider.preferredLanguage( prefered ); // app run içerisinde 
	$translateProvider.useSanitizeValueStrategy('escape');
	
  
})
.config(function($ionicConfigProvider) {

 $ionicConfigProvider.tabs.position('bottom');
 $ionicConfigProvider.views.transition('platform');
 $ionicConfigProvider.navBar.alignTitle('center');
 

})
.constant('_APP_SETTINGS', {
  file_system_dir: '.offr',
  external_file_system_dir: '.offr',
  root_dir: "file:///data/data/offr/files/",
  sd_root_dir: "file:///storage/emulated/0/Android/data/offr/files/",
  cache_max_age: 864000000, // saniye
  user_cookie_name: '_OFFR_USER',
  gcm_key_name: '_APP_GCM_REG_ID',
  camera_options: {
	width:640,
	height:640,
	quality: 90
  },  
  app_market_id: "com.offr.app",
  share_app_url: "https://play.google.com/store/apps/details?id=com.offr.app",
  share_app_image: "http://offr.ckrdk.com/img/icon.png",
  gcm_sender_id: "1063892922390",
  in_app_purchase_products: ['com.offr.app.vip1','com.offr.app.vip6','com.offr.app.per1','com.offr.app.per6'],
  default_subscription_prices: {'com.offr.app.vip1':'12.99', 'com.offr.app.vip6':'51.99', 'com.offr.app.per1':'3.99','com.offr.app.per6':'18.99'}, // currency:'$'
  in_app_purchase_onetime: [],
  server_app_id: 1,
  map_step_size: 0.01,//derece dk
  map_max_zoom: 15,
  map_min_zoom: 12,
  device_type: 1,
  max_agree_keep_count:100,
  version: '1.0.0',
  
})
.constant('_SERVER_SETTINGS',{
	mode: 'product',//development product
	std_auth_key: 'iof2980AMASJas0d7hka',
	api_url: 'http://offr.ckrdk.com/rest/', // /apiurl
	server_domain: "offr.ckrdk.com",
	server_url: "http://offr.ckrdk.com/",
	develop_api_url: 'http://offr.ckrdk.com/rest/',
	image_cdn_url: 'http://offr.ckrdk.com/pic/',
	file_cdn_url: 'http://offr.ckrdk.com/',
	google_maps_api_key: 'AIzaSyBc3ewllYqaEdixazJhklFddQxIjtu6S14', 
	 
})
.directive('scrolly', function () {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            var raw = element[0];
            
            
            element.bind('scroll', function () {
                
                if (raw.scrollTop + raw.offsetHeight + 5 >= raw.scrollHeight) {
                    
                        scope.$apply(attrs.scrolly);
                    
                }
            });
        }
    };
})
.directive('scrollyRevers', function () {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            var raw = element[0]; 
            
            element.bind('scroll', function () {
                 
                if (raw.scrollTop < 100)
                {
                     scope.$apply(attrs.scrollyRevers);
                     
                }
            });
        }
    };
})
/*.directive('onListScroll', function() {
return {
    
    link: function(scope, element, attrs) {
        var raw = element[0]; 
          
        element.bind("ready", function(event) {
            scope.$apply(attrs.onListScroll+'('+raw.scrollTop+','+raw.scrollHeight+')');
        });
    }
  };
})*/
.directive('isFocused', function($timeout) {
      return {
        scope: { trigger: '@isFocused' },
        link: function(scope, element) {
          scope.$watch('trigger', function(value) {
              //console.log("isFocused+"+value);
            if(value === "true") {
              $timeout(function() {
                element[0].focus();

                element.on('blur', function() {
                  if(value === "true")   
                  element[0].focus();
                });
              });
            }
            else{
                element.off('blur');
            }

          });
        }
      };
    })
.directive('errSrc', function(_SERVER_SETTINGS) {
  return {
    link: function(scope, element, attrs) {
      element.bind('error', function() {
		var image_src = (attrs.errSrc != '') ?  (attrs.errSrc)   : 'img/noimage.jpg';
		if(image_src == '') return;
		 
		//alert(the_src);
        if (attrs.src != image_src) {
          attrs.$set('src', image_src);
        }
      });
    }
  }
})
.directive('introPop', function(service_mcache, $ionicPopup,$filter,$ionicBackdrop,$timeout) {
  return {
    link: function(scope, element, attrs) {
        var bindTo = attrs.bindTo || 'click';

        var pfn = function(){
            var type = attrs.introPop, is_done = service_mcache.get('_INTRO_'+type) || false;
                
            if(!is_done)
            { 
                    var template = '' ;
                    switch(type)
                    {
                        case 'findAPartner':
                            template = '<div class="popWrap"><span class="bspin"></span><p>'+$filter('translate')('introtext.findAPartner')+'</p></div>';
                        break;
                        case 'myPartners':
                            template = '<div class="popWrap"><span class="bspin"></span><p>'+$filter('translate')('introtext.myPartners')+'</p></div>';
                        break;
                        case 'searchMenu':
                             template = '<div class="popWrap"><span class="bspin"></span><p>'+$filter('translate')('introtext.searchMenu')+'</p></div>';
                        break;
                    }
                    if(template != '')
                    {
                        
                        var alertPopup = $ionicPopup.alert({
                            cssClass: 'gpu_accelerate introPop '+type,
                            template: template ,
                            okText: $filter('translate')('Understood'),
                            okType: 'button-calm'
                        });
                        $ionicBackdrop.release();
                        
                        alertPopup.then(function(res) {
                            service_mcache.set('_INTRO_'+type, true);
                        });
                    }
            }
        };

        if(bindTo == 'ready')
        {
            angular.element(document).ready(function () {
                 pfn();
            });
        }
        else
        {
            element.bind(bindTo, function(){
                pfn();
            });
        }
    }
  }
})
.directive('ribbonCount', function($compile) {
  return {
    restrict: 'EA',
    scope: { 
            ribbonCount: "=ribbonCount" 
        },
    link: function(scope, element, attrs) {
        
        var unreg = scope.$watch('ribbonCount',function(newv,oldv){
               // console.log("scope newv"+newv+"+"+oldv);
            if(typeof newv != "undefined" && newv != 0)
            {
                var ribbon = '<span class="ribbon"></span>';
                element.after($compile(ribbon)(scope));
            }
            else
            {
                element[0].parentNode.querySelector('.ribbon').remove();
            }
        },true);
        
    }
  }
})
.directive('imgLoading', function($document,$timeout,$compile,$ionicScrollDelegate) {

  return {
       
    link: function(scope, element, attrs  ) {
			 
         element.addClass("hidden_image");
		 var imageloading =  '<ion-spinner icon="spiral" class="icon-center"></ion-spinner>';
		 element.after($compile(imageloading)(scope));
		 
         element.bind("load", function(){
			element.removeClass("hidden_image");
			element.parent().find("ion-spinner").remove();
		 }); 
          
    }
  }
})
.directive('uiMultiRange', MultiRangeDirective)
.directive('groupedRadio', function() {
  return {
    restrict: 'A',
    require: 'ngModel',
    scope: {
      model: '=ngModel',
      value: '=groupedRadio'
    },
    link: function(scope, element, attrs, ngModelCtrl) {
      element.addClass('button');
      element.on('click', function(e) {
        scope.$apply(function() {
          ngModelCtrl.$setViewValue(scope.value);
        });
      });

      scope.$watch('model', function(newVal) {
        element.removeClass('button-calm');
        if (newVal === scope.value) {
          element.addClass('button-calm');
        }
      });
    }
  };
})

.constant('_COUNTRY_LIST',[
    {
        "code": "AF",
        "name": "Afghanistan",
        "d_code": "93"
    },
    {
        "code": "AL",
        "name": "Albania",
        "d_code": "355"
    },
    {
        "code": "DZ",
        "name": "Algeria",
        "d_code": "213"
    },
    {
        "code": "AS",
        "name": "American Samoa",
        "d_code": "1"
    },
    {
        "code": "AD",
        "name": "Andorra",
        "d_code": "376"
    },
    {
        "code": "AO",
        "name": "Angola",
        "d_code": "244"
    },
    {
        "code": "AI",
        "name": "Anguilla",
        "d_code": "1"
    },
    {
        "code": "AG",
        "name": "Antigua",
        "d_code": "1"
    },
    {
        "code": "AR",
        "name": "Argentina",
        "d_code": "54"
    },
    {
        "code": "AM",
        "name": "Armenia",
        "d_code": "374"
    },
    {
        "code": "AW",
        "name": "Aruba",
        "d_code": "297"
    },
    {
        "code": "AU",
        "name": "Australia",
        "d_code": "61"
    },
    {
        "code": "AT",
        "name": "Austria",
        "d_code": "43"
    },
    {
        "code": "AZ",
        "name": "Azerbaijan",
        "d_code": "994"
    },
    {
        "code": "BH",
        "name": "Bahrain",
        "d_code": "973"
    },
    {
        "code": "BD",
        "name": "Bangladesh",
        "d_code": "880"
    },
    {
        "code": "BB",
        "name": "Barbados",
        "d_code": "1"
    },
    {
        "code": "BY",
        "name": "Belarus",
        "d_code": "375"
    },
    {
        "code": "BE",
        "name": "Belgium",
        "d_code": "32"
    },
    {
        "code": "BZ",
        "name": "Belize",
        "d_code": "501"
    },
    {
        "code": "BJ",
        "name": "Benin",
        "d_code": "229"
    },
    {
        "code": "BM",
        "name": "Bermuda",
        "d_code": "1"
    },
    {
        "code": "BT",
        "name": "Bhutan",
        "d_code": "975"
    },
    {
        "code": "BO",
        "name": "Bolivia",
        "d_code": "591"
    },
    {
        "code": "BA",
        "name": "Bosnia and Herzegovina",
        "d_code": "387"
    },
    {
        "code": "BW",
        "name": "Botswana",
        "d_code": "267"
    },
    {
        "code": "BR",
        "name": "Brazil",
        "d_code": "55"
    },
    {
        "code": "IO",
        "name": "British Indian Ocean Territory",
        "d_code": "246"
    },
    {
        "code": "VG",
        "name": "British Virgin Islands",
        "d_code": "1"
    },
    {
        "code": "BN",
        "name": "Brunei",
        "d_code": "673"
    },
    {
        "code": "BG",
        "name": "Bulgaria",
        "d_code": "359"
    },
    {
        "code": "BF",
        "name": "Burkina Faso",
        "d_code": "226"
    },
    {
        "code": "MM",
        "name": "Burma Myanmar",
        "d_code": "95"
    },
    {
        "code": "BI",
        "name": "Burundi",
        "d_code": "257"
    },
    {
        "code": "KH",
        "name": "Cambodia",
        "d_code": "855"
    },
    {
        "code": "CM",
        "name": "Cameroon",
        "d_code": "237"
    },
    {
        "code": "CA",
        "name": "Canada",
        "d_code": "1"
    },
    {
        "code": "CV",
        "name": "Cape Verde",
        "d_code": "238"
    },
    {
        "code": "KY",
        "name": "Cayman Islands",
        "d_code": "1"
    },
    {
        "code": "CF",
        "name": "Central African Republic",
        "d_code": "236"
    },
    {
        "code": "TD",
        "name": "Chad",
        "d_code": "235"
    },
    {
        "code": "CL",
        "name": "Chile",
        "d_code": "56"
    },
    {
        "code": "CN",
        "name": "China",
        "d_code": "86"
    },
    {
        "code": "CO",
        "name": "Colombia",
        "d_code": "57"
    },
    {
        "code": "KM",
        "name": "Comoros",
        "d_code": "269"
    },
    {
        "code": "CK",
        "name": "Cook Islands",
        "d_code": "682"
    },
    {
        "code": "CR",
        "name": "Costa Rica",
        "d_code": "506"
    },
    {
        "code": "CI",
        "name": null,
        "d_code": "225"
    },
    {
        "code": "HR",
        "name": "Croatia",
        "d_code": "385"
    },
    {
        "code": "CU",
        "name": "Cuba",
        "d_code": "53"
    },
    {
        "code": "CY",
        "name": "Cyprus",
        "d_code": "357"
    },
    {
        "code": "CZ",
        "name": "Czech Republic",
        "d_code": "420"
    },
    {
        "code": "CD",
        "name": "Democratic Republic of Congo",
        "d_code": "243"
    },
    {
        "code": "DK",
        "name": "Denmark",
        "d_code": "45"
    },
    {
        "code": "DJ",
        "name": "Djibouti",
        "d_code": "253"
    },
    {
        "code": "DM",
        "name": "Dominica",
        "d_code": "1"
    },
    {
        "code": "DO",
        "name": "Dominican Republic",
        "d_code": "1"
    },
    {
        "code": "EC",
        "name": "Ecuador",
        "d_code": "593"
    },
    {
        "code": "EG",
        "name": "Egypt",
        "d_code": "20"
    },
    {
        "code": "SV",
        "name": "El Salvador",
        "d_code": "503"
    },
    {
        "code": "GQ",
        "name": "Equatorial Guinea",
        "d_code": "240"
    },
    {
        "code": "ER",
        "name": "Eritrea",
        "d_code": "291"
    },
    {
        "code": "EE",
        "name": "Estonia",
        "d_code": "372"
    },
    {
        "code": "ET",
        "name": "Ethiopia",
        "d_code": "251"
    },
    {
        "code": "FK",
        "name": "Falkland Islands",
        "d_code": "500"
    },
    {
        "code": "FO",
        "name": "Faroe Islands",
        "d_code": "298"
    },
    {
        "code": "FM",
        "name": "Federated States of Micronesia",
        "d_code": "691"
    },
    {
        "code": "FJ",
        "name": "Fiji",
        "d_code": "679"
    },
    {
        "code": "FI",
        "name": "Finland",
        "d_code": "358"
    },
    {
        "code": "FR",
        "name": "France",
        "d_code": "33"
    },
    {
        "code": "GF",
        "name": "French Guiana",
        "d_code": "594"
    },
    {
        "code": "PF",
        "name": "French Polynesia",
        "d_code": "689"
    },
    {
        "code": "GA",
        "name": "Gabon",
        "d_code": "241"
    },
    {
        "code": "GE",
        "name": "Georgia",
        "d_code": "995"
    },
    {
        "code": "DE",
        "name": "Germany",
        "d_code": "49"
    },
    {
        "code": "GH",
        "name": "Ghana",
        "d_code": "233"
    },
    {
        "code": "GI",
        "name": "Gibraltar",
        "d_code": "350"
    },
    {
        "code": "GR",
        "name": "Greece",
        "d_code": "30"
    },
    {
        "code": "GL",
        "name": "Greenland",
        "d_code": "299"
    },
    {
        "code": "GD",
        "name": "Grenada",
        "d_code": "1"
    },
    {
        "code": "GP",
        "name": "Guadeloupe",
        "d_code": "590"
    },
    {
        "code": "GU",
        "name": "Guam",
        "d_code": "1"
    },
    {
        "code": "GT",
        "name": "Guatemala",
        "d_code": "502"
    },
    {
        "code": "GN",
        "name": "Guinea",
        "d_code": "224"
    },
    {
        "code": "GW",
        "name": "Guinea-Bissau",
        "d_code": "245"
    },
    {
        "code": "GY",
        "name": "Guyana",
        "d_code": "592"
    },
    {
        "code": "HT",
        "name": "Haiti",
        "d_code": "509"
    },
    {
        "code": "HN",
        "name": "Honduras",
        "d_code": "504"
    },
    {
        "code": "HK",
        "name": "Hong Kong",
        "d_code": "852"
    },
    {
        "code": "HU",
        "name": "Hungary",
        "d_code": "36"
    },
    {
        "code": "IS",
        "name": "Iceland",
        "d_code": "354"
    },
    {
        "code": "IN",
        "name": "India",
        "d_code": "91"
    },
    {
        "code": "ID",
        "name": "Indonesia",
        "d_code": "62"
    },
    {
        "code": "IR",
        "name": "Iran",
        "d_code": "98"
    },
    {
        "code": "IQ",
        "name": "Iraq",
        "d_code": "964"
    },
    {
        "code": "IE",
        "name": "Ireland",
        "d_code": "353"
    },
    {
        "code": "IL",
        "name": "Israel",
        "d_code": "972"
    },
    {
        "code": "IT",
        "name": "Italy",
        "d_code": "39"
    },
    {
        "code": "JM",
        "name": "Jamaica",
        "d_code": "1"
    },
    {
        "code": "JP",
        "name": "Japan",
        "d_code": "81"
    },
    {
        "code": "JO",
        "name": "Jordan",
        "d_code": "962"
    },
    {
        "code": "KZ",
        "name": "Kazakhstan",
        "d_code": "7"
    },
    {
        "code": "KE",
        "name": "Kenya",
        "d_code": "254"
    },
    {
        "code": "KI",
        "name": "Kiribati",
        "d_code": "686"
    },
    {
        "code": "XK",
        "name": "Kosovo",
        "d_code": "381"
    },
    {
        "code": "KW",
        "name": "Kuwait",
        "d_code": "965"
    },
    {
        "code": "KG",
        "name": "Kyrgyzstan",
        "d_code": "996"
    },
    {
        "code": "LA",
        "name": "Laos",
        "d_code": "856"
    },
    {
        "code": "LV",
        "name": "Latvia",
        "d_code": "371"
    },
    {
        "code": "LB",
        "name": "Lebanon",
        "d_code": "961"
    },
    {
        "code": "LS",
        "name": "Lesotho",
        "d_code": "266"
    },
    {
        "code": "LR",
        "name": "Liberia",
        "d_code": "231"
    },
    {
        "code": "LY",
        "name": "Libya",
        "d_code": "218"
    },
    {
        "code": "LI",
        "name": "Liechtenstein",
        "d_code": "423"
    },
    {
        "code": "LT",
        "name": "Lithuania",
        "d_code": "370"
    },
    {
        "code": "LU",
        "name": "Luxembourg",
        "d_code": "352"
    },
    {
        "code": "MO",
        "name": "Macau",
        "d_code": "853"
    },
    {
        "code": "MK",
        "name": "Macedonia",
        "d_code": "389"
    },
    {
        "code": "MG",
        "name": "Madagascar",
        "d_code": "261"
    },
    {
        "code": "MW",
        "name": "Malawi",
        "d_code": "265"
    },
    {
        "code": "MY",
        "name": "Malaysia",
        "d_code": "60"
    },
    {
        "code": "MV",
        "name": "Maldives",
        "d_code": "960"
    },
    {
        "code": "ML",
        "name": "Mali",
        "d_code": "223"
    },
    {
        "code": "MT",
        "name": "Malta",
        "d_code": "356"
    },
    {
        "code": "MH",
        "name": "Marshall Islands",
        "d_code": "692"
    },
    {
        "code": "MQ",
        "name": "Martinique",
        "d_code": "596"
    },
    {
        "code": "MR",
        "name": "Mauritania",
        "d_code": "222"
    },
    {
        "code": "MU",
        "name": "Mauritius",
        "d_code": "230"
    },
    {
        "code": "YT",
        "name": "Mayotte",
        "d_code": "262"
    },
    {
        "code": "MX",
        "name": "Mexico",
        "d_code": "52"
    },
    {
        "code": "MD",
        "name": "Moldova",
        "d_code": "373"
    },
    {
        "code": "MC",
        "name": "Monaco",
        "d_code": "377"
    },
    {
        "code": "MN",
        "name": "Mongolia",
        "d_code": "976"
    },
    {
        "code": "ME",
        "name": "Montenegro",
        "d_code": "382"
    },
    {
        "code": "MS",
        "name": "Montserrat",
        "d_code": "1"
    },
    {
        "code": "MA",
        "name": "Morocco",
        "d_code": "212"
    },
    {
        "code": "MZ",
        "name": "Mozambique",
        "d_code": "258"
    },
    {
        "code": "NA",
        "name": "Namibia",
        "d_code": "264"
    },
    {
        "code": "NR",
        "name": "Nauru",
        "d_code": "674"
    },
    {
        "code": "NP",
        "name": "Nepal",
        "d_code": "977"
    },
    {
        "code": "NL",
        "name": "Netherlands",
        "d_code": "31"
    },
    {
        "code": "AN",
        "name": "Netherlands Antilles",
        "d_code": "599"
    },
    {
        "code": "NC",
        "name": "New Caledonia",
        "d_code": "687"
    },
    {
        "code": "NZ",
        "name": "New Zealand",
        "d_code": "64"
    },
    {
        "code": "NI",
        "name": "Nicaragua",
        "d_code": "505"
    },
    {
        "code": "NE",
        "name": "Niger",
        "d_code": "227"
    },
    {
        "code": "NG",
        "name": "Nigeria",
        "d_code": "234"
    },
    {
        "code": "NU",
        "name": "Niue",
        "d_code": "683"
    },
    {
        "code": "NF",
        "name": "Norfolk Island",
        "d_code": "672"
    },
    {
        "code": "KP",
        "name": "North Korea",
        "d_code": "850"
    },
    {
        "code": "MP",
        "name": "Northern Mariana Islands",
        "d_code": "1"
    },
    {
        "code": "NO",
        "name": "Norway",
        "d_code": "47"
    },
    {
        "code": "OM",
        "name": "Oman",
        "d_code": "968"
    },
    {
        "code": "PK",
        "name": "Pakistan",
        "d_code": "92"
    },
    {
        "code": "PW",
        "name": "Palau",
        "d_code": "680"
    },
    {
        "code": "PS",
        "name": "Palestine",
        "d_code": "970"
    },
    {
        "code": "PA",
        "name": "Panama",
        "d_code": "507"
    },
    {
        "code": "PG",
        "name": "Papua New Guinea",
        "d_code": "675"
    },
    {
        "code": "PY",
        "name": "Paraguay",
        "d_code": "595"
    },
    {
        "code": "PE",
        "name": "Peru",
        "d_code": "51"
    },
    {
        "code": "PH",
        "name": "Philippines",
        "d_code": "63"
    },
    {
        "code": "PL",
        "name": "Poland",
        "d_code": "48"
    },
    {
        "code": "PT",
        "name": "Portugal",
        "d_code": "351"
    },
    {
        "code": "PR",
        "name": "Puerto Rico",
        "d_code": "1"
    },
    {
        "code": "QA",
        "name": "Qatar",
        "d_code": "974"
    },
    {
        "code": "CG",
        "name": "Republic of the Congo",
        "d_code": "242"
    },
    {
        "code": "RE",
        "name": null,
        "d_code": "262"
    },
    {
        "code": "RO",
        "name": "Romania",
        "d_code": "40"
    },
    {
        "code": "RU",
        "name": "Russia",
        "d_code": "7"
    },
    {
        "code": "RW",
        "name": "Rwanda",
        "d_code": "250"
    },
    {
        "code": "BL",
        "name": null,
        "d_code": "590"
    },
    {
        "code": "SH",
        "name": "Saint Helena",
        "d_code": "290"
    },
    {
        "code": "KN",
        "name": "Saint Kitts and Nevis",
        "d_code": "1"
    },
    {
        "code": "MF",
        "name": "Saint Martin",
        "d_code": "590"
    },
    {
        "code": "PM",
        "name": "Saint Pierre and Miquelon",
        "d_code": "508"
    },
    {
        "code": "VC",
        "name": "Saint Vincent and the Grenadines",
        "d_code": "1"
    },
    {
        "code": "WS",
        "name": "Samoa",
        "d_code": "685"
    },
    {
        "code": "SM",
        "name": "San Marino",
        "d_code": "378"
    },
    {
        "code": "ST",
        "name": null,
        "d_code": "239"
    },
    {
        "code": "SA",
        "name": "Saudi Arabia",
        "d_code": "966"
    },
    {
        "code": "SN",
        "name": "Senegal",
        "d_code": "221"
    },
    {
        "code": "RS",
        "name": "Serbia",
        "d_code": "381"
    },
    {
        "code": "SC",
        "name": "Seychelles",
        "d_code": "248"
    },
    {
        "code": "SL",
        "name": "Sierra Leone",
        "d_code": "232"
    },
    {
        "code": "SG",
        "name": "Singapore",
        "d_code": "65"
    },
    {
        "code": "SK",
        "name": "Slovakia",
        "d_code": "421"
    },
    {
        "code": "SI",
        "name": "Slovenia",
        "d_code": "386"
    },
    {
        "code": "SB",
        "name": "Solomon Islands",
        "d_code": "677"
    },
    {
        "code": "SO",
        "name": "Somalia",
        "d_code": "252"
    },
    {
        "code": "ZA",
        "name": "South Africa",
        "d_code": "27"
    },
    {
        "code": "KR",
        "name": "South Korea",
        "d_code": "82"
    },
    {
        "code": "ES",
        "name": "Spain",
        "d_code": "34"
    },
    {
        "code": "LK",
        "name": "Sri Lanka",
        "d_code": "94"
    },
    {
        "code": "LC",
        "name": "St. Lucia",
        "d_code": "1"
    },
    {
        "code": "SD",
        "name": "Sudan",
        "d_code": "249"
    },
    {
        "code": "SR",
        "name": "Suriname",
        "d_code": "597"
    },
    {
        "code": "SZ",
        "name": "Swaziland",
        "d_code": "268"
    },
    {
        "code": "SE",
        "name": "Sweden",
        "d_code": "46"
    },
    {
        "code": "CH",
        "name": "Switzerland",
        "d_code": "41"
    },
    {
        "code": "SY",
        "name": "Syria",
        "d_code": "963"
    },
    {
        "code": "TW",
        "name": "Taiwan",
        "d_code": "886"
    },
    {
        "code": "TJ",
        "name": "Tajikistan",
        "d_code": "992"
    },
    {
        "code": "TZ",
        "name": "Tanzania",
        "d_code": "255"
    },
    {
        "code": "TH",
        "name": "Thailand",
        "d_code": "66"
    },
    {
        "code": "BS",
        "name": "The Bahamas",
        "d_code": "1"
    },
    {
        "code": "GM",
        "name": "The Gambia",
        "d_code": "220"
    },
    {
        "code": "TL",
        "name": "Timor-Leste",
        "d_code": "670"
    },
    {
        "code": "TG",
        "name": "Togo",
        "d_code": "228"
    },
    {
        "code": "TK",
        "name": "Tokelau",
        "d_code": "690"
    },
    {
        "code": "TO",
        "name": "Tonga",
        "d_code": "676"
    },
    {
        "code": "TT",
        "name": "Trinidad and Tobago",
        "d_code": "1"
    },
    {
        "code": "TN",
        "name": "Tunisia",
        "d_code": "216"
    },
    {
        "code": "TR",
        "name": "Turkey",
        "d_code": "90"
    },
    {
        "code": "TM",
        "name": "Turkmenistan",
        "d_code": "993"
    },
    {
        "code": "TC",
        "name": "Turks and Caicos Islands",
        "d_code": "1"
    },
    {
        "code": "TV",
        "name": "Tuvalu",
        "d_code": "688"
    },
    {
        "code": "UG",
        "name": "Uganda",
        "d_code": "256"
    },
    {
        "code": "UA",
        "name": "Ukraine",
        "d_code": "380"
    },
    {
        "code": "AE",
        "name": "United Arab Emirates",
        "d_code": "971"
    },
    {
        "code": "GB",
        "name": "United Kingdom",
        "d_code": "44"
    },
    {
        "code": "US",
        "name": "United States",
        "d_code": "1"
    },
    {
        "code": "UY",
        "name": "Uruguay",
        "d_code": "598"
    },
    {
        "code": "VI",
        "name": "US Virgin Islands",
        "d_code": "1"
    },
    {
        "code": "UZ",
        "name": "Uzbekistan",
        "d_code": "998"
    },
    {
        "code": "VU",
        "name": "Vanuatu",
        "d_code": "678"
    },
    {
        "code": "VA",
        "name": "Vatican City",
        "d_code": "39"
    },
    {
        "code": "VE",
        "name": "Venezuela",
        "d_code": "58"
    },
    {
        "code": "VN",
        "name": "Vietnam",
        "d_code": "84"
    },
    {
        "code": "WF",
        "name": "Wallis and Futuna",
        "d_code": "681"
    },
    {
        "code": "YE",
        "name": "Yemen",
        "d_code": "967"
    },
    {
        "code": "ZM",
        "name": "Zambia",
        "d_code": "260"
    },
    {
        "code": "ZW",
        "name": "Zimbabwe",
        "d_code": "263"
    }
]);
