angular.module('starter.controllers')

.controller('loginCtrl', function($scope, $state, $timeout, $filter, $ionicPopup, $ionicLoading, $timeout, $document, $translate, $ionicHistory, $ionicPlatform, service_user, service_login, service_mcache, service_api, service_inapppurchase,  _APP_SETTINGS){

	var login = {};
	$ionicLoading.show();
	login.show_login_page = false;
	$timeout(function(){ 
		login.lang = $translate.use();
		login.logo = "logo-"+login.lang+".png";
	},1000);
	
	login.set_user_type = function(type)
	{
		$ionicLoading.show();
		service_user.update({user_type:type})
		.then(function(){
			service_user.refresh()
			.then(function(){
				$ionicLoading.hide();
				if(service_user.getUserType() <= 1)
				{
					
					$state.go('tab.find');
					return;
				}
				else if(service_user.getUserType() == 2)
				{
					
					if(service_user.isSaloonAdded())
					$state.go('buss.reservations');
					else
					$state.go('buss.upgrade');
					return;
				}
			});
		},function(){});
	};
	 
	
	$ionicHistory.nextViewOptions({ 
	  //historyRoot: true
	  disableBack: true
	});
	
	login.fire_ready = false;
	
	$scope.$on("$ionicView.enter", function(){
		 
	   if(service_mcache.get(_APP_SETTINGS.user_cookie_name))
		{	
			
			$ionicLoading.hide();
			if(service_user.getUserType() != 0)
			{
				if(service_user.getUserType() <= 1)
				{
					 
					$state.go('tab.find');
				}
				else if(service_user.getUserType() == 2)
				{
					//alert(service_user.isSaloonAdded());
					if(service_user.isSaloonAdded())
					$state.go('buss.reservations');
					else
					$state.go('buss.upgrade');
				}
				return;
			}
			else
			{
				login.fire_ready = true;
				// user type seçsin
				login.show_login_page = true;
				return;
			}
		}
		else
		login.fire_ready = true;
	});
		
	 
	 $ionicPlatform.ready(function() {
	 
		
		 
		$timeout(function(){
			//if(!login.fire_ready) return;
		
			var unique_device_hash = service_mcache.get("_DEVICE_UUID");
			
			if(!unique_device_hash)
			{	
				$ionicLoading.hide();
				login.show_login_page = true;
			}
			else
			{
				
				  if(!service_mcache.get(_APP_SETTINGS.user_cookie_name))
				  {
					$ionicLoading.show();
						// burada kayıt yapalım
						service_login.register(unique_device_hash+"@android.com", unique_device_hash)
						.then(function(){
							 
								$timeout(function(){
									$ionicLoading.hide();
									if(service_user.getUserType() != 0)
									{
										if(service_user.getUserType() <= 1)
										{
											
											$state.go('tab.find');
										}else if(service_user.getUserType() == 2)
										{
											 
											if(service_user.isSaloonAdded())
											$state.go('buss.reservations');
											else
											$state.go('buss.upgrade');
										}
									}
									else
									login.show_login_page = true;
								    
								}, 2000);
								
						},function(error_message){
							 
							$ionicLoading.hide();
							login.show_login_page = true;
							
						});
				}	
				 
				
			}
			
		},2500);
	});
	
	
	login.found_accounts = [];
	
	  
	
	login.data = {};
	login.klass = {};
	
	login.signin = function()
	{
		var template = '';
		
		 
	 
			 
			
			template +=  '<label class="item item-input item-floating-label">';
				template +=  '<span class="input-label">'+$filter('translate')('Email')+'</span>';
				template +=  '<input type="email" placeholder="'+$filter('translate')('Email')+'" class="text-center" ng-class="login.klass.email" ng-model="login.data.email" >';
			template +=  '</label>';
			
			if(login.found_accounts.length > 0)
			{
				template +=  '<h6>'+$filter('translate')('or_choose')+'</h6>';
			 
				template +=  '<ion-list type="list-inset">';
				for(var e in login.found_accounts)
				{
					var the_acc = login.found_accounts[e];
					template += '<ion-item  ng-click="login.data.email = \''+the_acc.name+'\'">'+the_acc.name+'</ion-item>';
				}
				template +=  '</ion-list>';
				 
			}
			
			template +=  '<label class="item item-input item-floating-label">';
				template +=  '<span class="input-label">'+$filter('translate')('Password')+'</span>';
				template +=  '<input type="password" placeholder="'+$filter('translate')('Password')+'" class="text-center" ng-class="login.klass.password" ng-model="login.data.password" >';
			template +=  '</label>';
		 
		 
		
		var myPopup = $ionicPopup.show({
			template: template,
			title: $filter('translate')('Login'),
			scope: $scope,
			cssClass: 'form_popup scroll no_pop_title',
			buttons: [
				{
					text: $filter('translate')('PasswordLost'),
					type: 'button-stable',
					onTap: function(e) {
						e.preventDefault();
						
						if(!login.data.email)
						{
							login.klass.email = 'strong_border_not_ok';
						}else
						  login.klass.email = 'strong_border_ok';
							
						 
						if(login.data.email)
						{
							$ionicLoading.show();
							service_login.lostpw(login.data.email)
							.then(function(res){
								 
								 if(res.error == 0)
								 {
								
									var iconPop = $ionicPopup.show({
																template: $filter('translate')('PasswordSent'),
																buttons: [],
																cssClass: 'no_pop_title success'
															  });
									$timeout(function(){
												 iconPop.close(); 
											  }, 2000);
											  
								}
								else
								{
									var iconPop = $ionicPopup.show({
																template: $filter('translate')('EmailNotRegistered'),
																buttons: [],
																cssClass: 'no_pop_title danger'
															  });
									$timeout(function(){
												 iconPop.close(); 
											  }, 2000);
								}
								$ionicLoading.hide();
							},function(){
									var iconPop = $ionicPopup.show({
																template: '<i class="ion-ios-minus"></i>',
																buttons: [],
																cssClass: 'only-icon-popup danger'
															  });
									$timeout(function(){
												  
												 iconPop.close(); 
											  }, 2000);
								$ionicLoading.hide();
							});
						}
					}
			  }, 
			  {
				text: '<b>'+$filter('translate')('Login')+'</b>',
				type: 'button-calm',
				onTap: function(e) {
				   
					e.preventDefault();
					
					if(!login.data.email)
					{
						login.klass.email = 'strong_border_not_ok';
					}else
						login.klass.email = 'strong_border_ok';
						
					if(!login.data.password)
					{
						login.klass.password = 'strong_border_not_ok';
					}else
						login.klass.password = 'strong_border_ok';
					
					if(login.data.email && login.data.password)
					{
						$ionicLoading.show();
						
						service_login.signin(login.data.email, login.data.password)
						.then(function(){
							myPopup.close();
							service_inapppurchase.onlogin();
							var iconPop = $ionicPopup.show({
															template: '<i class="ion-ios-checkmark"></i>',
															buttons: [],
															cssClass: 'only-icon-popup success'
														  });
								$timeout(function(){
											//$ionicHistory.clearCache();
											//$ionicHistory.clearHistory();
											$state.go("tab.find");
											 iconPop.close(); 
										  }, 2000);
								$ionicLoading.hide();
						},function(){
								var iconPop = $ionicPopup.show({
															template: $filter('translate')('SomeInfoWrong'),
															buttons: [],
															cssClass: 'no_pop_title danger'
														  });
								$timeout(function(){
											 iconPop.close(); 
										  }, 2000);
								$ionicLoading.hide();
						});
					}
				 
				}
			  }
			]
		  }); 
		  
		  $document.on('click', function (event) {
				if (event.target.nodeName === 'HTML')
				{
					if (myPopup)
					{
						myPopup.close();
					}
				}
			});
		
	};
	
	login.register = function()
	{
		var template = '';
		
		 
	 
			 
			
			template +=  '<label class="item item-input item-floating-label">';
				template +=  '<span class="input-label">'+$filter('translate')('Email')+'</span>';
				template +=  '<input type="email" placeholder="'+$filter('translate')('Email')+'" class="text-center" ng-class="login.klass.email" ng-model="login.data.email" >';
			template +=  '</label>';
			
			if(login.found_accounts.length > 0)
			{
				template +=  '<h6>'+$filter('translate')('or_choose')+'</h6>';
			 
				template +=  '<ion-list type="list-inset">';
				for(var e in login.found_accounts)
				{
					var the_acc = login.found_accounts[e];
					template += '<ion-item  ng-click="login.data.email = \''+the_acc.name+'\'">'+the_acc.name+'</ion-item>';
				}
				template +=  '</ion-list>';
				 
			}
			
			template +=  '<label class="item item-input item-floating-label">';
				template +=  '<span class="input-label">'+$filter('translate')('Password')+'</span>';
				template +=  '<input type="password" placeholder="'+$filter('translate')('Password')+'" class="text-center" ng-class="login.klass.password" ng-model="login.data.password" >';
			template +=  '</label>';
		 
			template +=  '<label class="item item-input item-floating-label">';
				template +=  '<span class="input-label">'+$filter('translate')('PasswordAgain')+'</span>';
				template +=  '<input type="password" placeholder="'+$filter('translate')('PasswordAgain')+'" class="text-center" ng-class="login.klass.password" ng-model="login.data.password2" >';
			template +=  '</label>';
		 
		 
		
		var myPopup = $ionicPopup.show({
			template: template,
			title: 'Kayıt',
			scope: $scope,
			cssClass: 'form_popup scroll no_pop_title',
			buttons: [ 
			  {
				text: '<b>'+$filter('translate')('Register')+'</b>',
				type: 'button-calm',
				onTap: function(e) {
				   
					e.preventDefault();
					
					if(!login.data.email)
					{
						login.klass.email = 'strong_border_not_ok';
					}else
						login.klass.email = 'strong_border_ok';
						
					if(!login.data.password  )
					{
						login.klass.password = 'strong_border_not_ok';
					}else
						login.klass.password = 'strong_border_ok';
						
					if(!login.data.password2  )
					{
						login.klass.password = 'strong_border_not_ok';
					}else
						login.klass.password = 'strong_border_ok';
						
					if(login.data.password2 != login.data.password)
					{
						login.klass.password = 'strong_border_not_ok';
					}else
					{
						if(login.data.password.length < 5)
						{
							login.klass.password = 'strong_border_not_ok';
						}
						else
						login.klass.password = 'strong_border_ok';
						
					}	
					
					if(login.data.email && login.data.password && login.data.password2 == login.data.password && login.data.password.length >= 5)
					{
						$ionicLoading.show();
						service_login.register(login.data.email, login.data.password)
						.then(function(){
							myPopup.close();
							var iconPop = $ionicPopup.show({
															template: '<i class="ion-ios-checkmark"></i>',
															buttons: [],
															cssClass: 'only-icon-popup success'
														  });
								$timeout(function(){
									 
											$state.go("tab.find");
											 iconPop.close(); 
										  }, 2000);
								$ionicLoading.hide();
						},function(error_message){
							//console.log("error_message"+error_message);
							
							 var error_text = '';
							 switch(error_message)
							 {
								default:
									error_text =  $filter('translate')('RegisterError');
								break;
								case 'email_already_exists':
									error_text =  $filter('translate')('email_already_exists');
								break;
								case 'device_already_registered':
									error_text =  $filter('translate')('device_already_registered');
								break;
							 }
							 var iconPop = $ionicPopup.show({
															template: error_text,
															buttons: [],
															cssClass: 'no_pop_title danger'
														  });
								$timeout(function(){
											 iconPop.close(); 
										  }, 4000);
							$ionicLoading.hide();
						});
					}
				 
				}
			  }
			]
		  }); 
		  
		  $document.on('click', function (event) {
				if (event.target.nodeName === 'HTML')
				{
					if (myPopup)
					{
						myPopup.close();
					}
				}
			});
		
	};
	
	//$ionicLoading.hide();
	$scope.login = login;
	
});