angular.module('starter.controllers')

.controller('messageCtrl', function($rootScope, $scope, $state, $stateParams, $window, $document, $ionicHistory, $ionicLoading, $ionicPlatform, $ionicPopup, $timeout, $filter, service_message, service_timelabel, service_user, service_nativeaudio, _SERVER_SETTINGS){

	 var user = service_user.getUser();
     var message = {};


     message.cid = $stateParams.cid || 0;
     

     message.limit = 10;
     message.list = [];
     message.can_load_more = false;
     message.page = 1;
     message.cdn = _SERVER_SETTINGS.image_cdn_url;
     message.target_user = {};
     message.show_loading = false;
     message.timeago = service_timelabel.timeago;
     message.get_messages = function(force){
        if(force)
        {
            message.list = [];
            message.page = 1;
            
        }
         
        message.show_loading = true;

        service_message.get_messages(message.cid, message.page)
        .then(function(res){
             message.show_loading = false;
             $scope.$broadcast('scroll.refreshComplete');
             $scope.$broadcast('scroll.infiniteScrollComplete');
            if(res.error == 0)
            {
                //res.data.messages = res.data.messages.reverse();
                res.data.messages.forEach(function(item){
                    message.list.splice(0,0,item);
                });

                if(res.data.messages.length < message.limit)
                {
                    message.can_load_more = false;
                }
                else
                    message.can_load_more = true;

                message.target_user = res.data.target_user;
                if(message.page == 1)
                {
                   
                        message.scroll_to_bottom(150);
                    
                }
            }

        },function(){
             message.show_loading = false;
             $scope.$broadcast('scroll.refreshComplete');
             $scope.$broadcast('scroll.infiniteScrollComplete');
        })

     }

     message.toggle_block = function(target_user_id){
        service_message.toggle_block(target_user_id)
        .then(function(){
            var alertPopup = $ionicPopup.alert({
                
                template: '<i class="ion-ios-checkmark balanced">',
                cssClass: 'successPopup',
            });

            $timeout(function() {
                alertPopup.close(); //close the popup after 3 seconds for some reason
            }, 2000);
        },function(){
            var alertPopup = $ionicPopup.alert({
                
                template: '<i class="ion-ios-close assertive">',
                cssClass: 'successPopup',
            });

            $timeout(function() {
                alertPopup.close(); //close the popup after 3 seconds for some reason
            }, 2000);
        })
     }

     message.report_user = function(target_user_id){
        service_user.report_abuse(target_user_id);
        var alertPopup = $ionicPopup.alert({
                
                template: '<i class="ion-ios-checkmark balanced">',
                cssClass: 'successPopup',
            });

            $timeout(function() {
                alertPopup.close(); //close the popup after 3 seconds for some reason
            }, 2000);
     }
     message.show_actions_pop = function(){
         if( message.target_user)
         {
            service_message.get_block(message.target_user.user_id)
            .then(function(res){
                if(res.error == 0)
                {
                    var blocked = res.data.is_blocked;
                        var template = '';
                        if(!blocked)
                        template += '<button class="button dark button-dark button-block button-small button-outline" ng-click="message.toggle_block('+message.target_user.user_id+');" >'+$filter('translate')('BlockUser')+'</button>'; 
                        else
                        template += '<button class="button dark button-dark button-block button-small button-outline" ng-click="message.toggle_block('+message.target_user.user_id+');" >'+$filter('translate')('UnblockUser')+'</button>'; 
                        
                        template += '<button class="button dark button-dark button-block button-small button-outline" ng-click="message.report_user('+message.target_user.user_id+');" >'+$filter('translate')('ReportAbuse2')+'</button>'; 
                        var popup = $ionicPopup.show({
                                scope: $scope,
                                template: template,
                                cssClass: 'buttons_pop hide_pop_buttons hide_pop_head',
                            });

                            popup.then(function(res) {
                               // console.log('Thank you for not eating my delicious ice cream cone');
                            });
                }
            })
         }
     }

     

     message.scroll_to_bottom = function(to){
          $timeout(function(){
           // if($document[0].getElementById('scolling_list').length > 0)
            $document[0].getElementById('scolling_list').scrollTop = 100000000;
          },to||600);
     };

     message.load_more = function(){

         if(message.can_load_more == true)
         {
            if(angular.isDefined(message.load_more_timeout)) $timeout.cancel(message.load_more_timeout);
            message.load_more_timeout = $timeout(function(){
                message.page++;
                message.get_messages();
            },300);
        }  

     }

     message.text = '';


     
     message.send_message = function()
     {
        message.is_keyboard_focused = true;
        if( message.text.replace(/\s/g).length > 0 )
        {
           var message_index =  message.push_new_message(user.user_id, message.text,-1);
            service_message.send_message(message.target_user.user_id, message.text)
            .then(function(res){
                if(res.error == 0)
                {
                    message.update_message(message_index, 0, res.data.message_id);
                    message.text = '';
                    service_nativeaudio.new_message(true);
                }
                else
                {
                     message.update_message(message_index,-2);
                }
                message.is_keyboard_focused = false;
            },function(){
                message.update_message(message_index,-2);
                message.is_keyboard_focused = false;
            })
        }    
     }
     //-2 = hata, -1 beklemede, 0= gönderildi 1= görüldü
     message.push_new_message = function(from, text, is_seen){
         //{"message_id":"4","cid":"2","sender_id":"2","message":"Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf Svsdbaanfaf ","is_seen":"0","is_active_u1":"1","is_active_u2":"1","added_date":"2017-05-10 18:35:40","passed_secs":"75394","is_me":"0"}

         if(!is_seen) is_seen = 0

         var the_message = {"message_id":0,"cid":message.cid,"sender_id":from,"message":text,"is_seen":is_seen,"is_active_u1":1,"is_active_u2":1,"added_date":"","passed_secs":1,"is_me":(user.user_id == from ? 1 : 0)};
         //console.warn("THE MESAAJ"+JSON.stringify(the_message))
         message.list.push(the_message);
         message.scroll_to_bottom(100);

         return message.list.length - 1;
     }

     message.update_message = function(index, state, message_id)
     {
       // console.warn("update_message index"+index)
        if(message.list[index])
        {
            if(state != null)
            { 
                message.list[index].is_seen = state; 
            }
            if(message_id != null)
            {
                message.list[index].message_id = message_id;
            }
             
        }
     }
     message.stringify_array = function(arr){
        var n = [];
        arr.forEach(function(e){n.push(e.toString());});
        return n;
     }
     message.update_message_by_message_id = function(message_ids, state)
     {
        message_ids = message.stringify_array(message_ids);
         message.list.forEach(function(e,index){
 
             if(message_ids.indexOf(e.message_id.toString() ) > -1)
             {
                message.list[index].is_seen = state; 
                 
                //console.warn("message.list["+index+"].is_seen "+JSON.stringify(message.list[index]) +"-"+state)
             }
        });
         
     }
     message.set_all_seen = function(){
         message.list.forEach(function(e){
             e.is_seen = 1;
         })
     }
     
     message.get_state_icon = function(state)
     {
          //-2 = hata, -1 beklemede, 0= gönderildi 1= görüldü
          var icon =  '';
          state = parseInt(state);
          switch(state)
          {
            case -2:
                icon = 'ion-ios-close-outline assertive';
            break;
            case -1:
                icon = 'ion-ios-clock-outline';
            break;
            case 0:
                icon = 'ion-ios-checkmark-outline';
            break;
            case 1:
                icon = 'ion-ios-checkmark positive';
            break;

          }
          return icon;
     }

     message.is_keyboard_focused = false;

     message.write_focused = function(){
       
         message.scroll_to_bottom();

     }
     message.text_change = function(){
         if(message.text.length > 0)
         message.is_keyboard_focused=true;
         else
         message.is_keyboard_focused=false;
     }

     $scope.$on("native.keyboardhide",function(){
         message.is_keyboard_focused = false;
         $window.cordova.plugins.Keyboard.close();
     })

     
     $scope.$on("onPushNotification",function(event,data){
         // !!! bildirim geldi, mesaj datasımı kontrol et!!! yeni mesajsa işlem yap,
        /*
            GELEN TİPLER:
            1- YENİ MESAJ GELDİ
            2- MESAJ GÖRÜLDÜ is_seen = 1 GELDİ
        */
        
        // 
        if(data.additionalData.data_message)
        {
            switch(data.additionalData.data_message.type )
            {
                case 'new_message':
                    var msg = data.additionalData.data_message.data;
                     $timeout(function(){
                        message.set_all_seen();
                        message.push_new_message(msg.sender_id, msg.message, 1);
                        service_message.send_seen(message.cid, message.target_user.user_id,msg.message_id);
                     });
                break;
                case 'message_seen':
                    var msg = data.additionalData.data_message.data; 
                    
                    $timeout(function(){
                        message.update_message_by_message_id(msg.message_ids, 1);
                        message.set_all_seen();
                    });
                     
                break;
            }
        }
        
     });

     $window.onPauseEvents.push(  function(){
            $ionicPlatform.on('resume', function(){
                
                message.get_messages();
                
            });
        }
     );

     $scope.message = message;


     $scope.$on("$ionicView.enter",function(){
        $timeout(function(){
            
            message.get_messages();
        })
    });


        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
 
            viewData.enableBack = true;
        });
        $rootScope.$ionicGoBack = function() {
            $ionicHistory.goBack() || $state.go("app.messages");
            message.is_keyboard_focused = false;
            $window.cordova.plugins.Keyboard.close();
        };
});