angular.module('starter.controllers')

.controller('profileCtrl', function($rootScope, $scope, $state, $window, $ionicHistory, $ionicLoading, $filter, $timeout, $ionicPopup, service_capture, service_user, service_api, service_lzstring, service_upload, service_share, _SERVER_SETTINGS ){

    var user = service_user.getUser();
   // console.log("USER"+JSON.stringify(user))
   
    $scope.$on( "$ionicView.enter", function( ) {
        cordova.plugins.diagnostic.requestCameraAuthorization(function(){
            CameraPreview.stopCamera();
        },function(){
            
        });
    });
   

	 var profile = {};

     profile.images = [0,0,0,0,0];

     if(user.images && user.images.length > 0)
     user.images.forEach(function(item){
         profile.images.splice(item.ordering,1);
         profile.images.splice(item.ordering,0,item.image_id)
     });


     profile.name = user.name;
     profile.age = parseInt(user.age) || null;
     profile.gender = parseInt(user.gender) ;
     profile.about = user.about; 
     profile.job = user.job;

     profile.cdn = _SERVER_SETTINGS.image_cdn_url;

     profile.user_id = "#"+user.user_id;
     profile.is_premium = user.is_premium;
     profile.is_persuader = user.is_persuader;
      

     profile.selected_image_id = user.user_image_id;

     profile.share_pic = function(file)
     {
        service_share.share_pic(file+".gif");
     }

      
     profile.save_user_info = function(info){
           
        if(angular.isDefined(profile.save_timeout) ) $timeout.cancel(profile.save_timeout) ;
        profile.save_timeout = $timeout(function(){
           service_user.update({name: profile.name, age:profile.age, gender:profile.gender, about:profile.about, job: profile.job});
            if($window.plugins && $window.plugins.toast)
            $window.plugins.toast.showShortTop($filter('translate')('SavedSuccessfully'));
        },750);

     };


     profile.image_chooser = function(index){
        var myPopup = $ionicPopup.show({
                                         
                                        scope: $scope,
                                        cssClass: 'pop-only-buttons',
                                        buttons: [
                                        { text: '',
                                            type: 'button-calm button-icon icon ion-images',
                                             onTap: function(e) {
                                            
                                                //e.preventDefault();
                                                service_upload.choose_photo()
                                                .then(function(res){
                                                     $ionicLoading.show({
                                                        template: $filter('translate')('CreatingPic')
                                                        });
                                                    service_upload.save(res,"app.common.uploader",{ordering:index})
                                                    .then(function(res){
                                                        if(res.error == 0)
                                                        {
                                                            service_user.refresh();
                                                            profile.images.splice(index,1);
                                                            profile.images.splice(index,0,res.data.image_id);
                                                            
                                                            if($window.plugins && $window.plugins.toast)
                                                            $window.plugins.toast.showShortTop($filter('translate')('SavedSuccessfully'));
                                                        }
                                                        $ionicLoading.hide();
                                                    },function(){
                                                        $ionicLoading.hide();
                                                    })

                                                },function(){
                                                    
                                                })
                                                
                                            
                                            }
                                        },
                                        {
                                            text: '',
                                            type: 'button-calm button-icon icon ion-camera',
                                            onTap: function(e) {
                                            
                                               // e.preventDefault();
                                               service_upload.take_photo()
                                                .then(function(res){
                                                     $ionicLoading.show({
                                                        template: $filter('translate')('CreatingPic') 
                                                        });
                                                    service_upload.save(res,"app.common.uploader",{ordering:index})
                                                    .then(function(res){
                                                        if(res.error == 0)
                                                        {
                                                            service_user.refresh();
                                                            profile.images.splice(index,1);
                                                            profile.images.splice(index,0,res.data.image_id);
                                                            if($window.plugins && $window.plugins.toast)
                                                            $window.plugins.toast.showShortTop($filter('translate')('SavedSuccessfully'));
                                                        }
                                                        $ionicLoading.hide();
                                                    },function(){
                                                        $ionicLoading.hide();
                                                    })
                                                },function(){
                                                    
                                                });
                                            
                                            }
                                        }
                                        ]
                                    });
     };
      

     profile.new_photo = function(index){ 
        
            profile.take_gif(); 
     };
     
     

     profile.startCamera = function(){
       
        service_capture.startCamera()
        .then(function(){
            profile.show_cam_controls = 1;
        })

     };
     profile.stopCamera = function(){
         $timeout(function(){
            service_capture.stopCamera()
            .then(function(){
                profile.show_cam_controls = 0;
            });
         },100);
     };
     profile.toggleSepia = function(){
        service_capture.toggle_sepia();
        
     };
     profile.toggleMono = function(){
        service_capture.toggle_bw();
     };

     profile.toggleFlash = function(){
         service_capture.toggle_flash();
     }

     profile.take_gif = function()
     {
 
            service_capture.takePhotos(8)
            .then(function(res){
                 $ionicLoading.show({
                    template: $filter('translate')('CreatingGif') 
                    });
                    profile.stopCamera();
                // console.warn("CAMRES",JSON.stringify(res));
                profile.images.splice(0,1);
                profile.images.splice(0,0,0);
                service_capture.createGif(res)
                .then(function(gif){
                    delete res;
                    if(!gif.error)
                    {
                        service_api.post("app.common.uploaderbase64",{filedata: gif.image, ext:"gif"},true)
                        .then(function(imgs){
                            //console.log("UPLOAD_RES"+JSON.stringify(imgs));
                            if(imgs.error == 0)
                            {
                                service_user.refresh();
                                profile.images[0] = imgs.data.image_id;
                                if($window.plugins && $window.plugins.toast)
                                $window.plugins.toast.showShortTop($filter('translate')('SavedSuccessfully'));
                            }
                            $ionicLoading.hide();
                            delete gif ;
                        },function(){
                           // console.error("post error")
                            $ionicLoading.hide();
                        });
                    }
                    else
                    {
                        // hata oldu
                        var alertPopup = $ionicPopup.alert({
                            title: $filter('translate')('Error'),
                            template: $filter('translate')('ErrorOccurredTryAgain')
                        });
                    }
                     
                    
                },function(){
                     $ionicLoading.hide();
                });
            },function(err){
                console.err("CAMRESerr",JSON.stringify(err));
            });
        
     };


            
    profile.image_selected_index = 0;
     profile.show_photo = function(index){
        profile.selected_image_id = profile.images[index];
        profile.image_selected_index = index;
     };
        
    


     $scope.profile = profile;

     $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
 
            viewData.enableBack = true;
        });
    $rootScope.$ionicGoBack = function() {
           $ionicHistory.goBack() || $state.go("app.search");
    };
});