angular.module('starter.controllers')

.controller('settingsCtrl', function($rootScope, $scope, $state, $window, $ionicHistory, $translate, service_user, service_mcache, service_share){

	 var settings = {};

    
    settings.current_lang = $translate.use();

    settings.all_langs = [];
    Object.keys($window.langs).forEach(function(a){
        settings.all_langs.push({key:a, name:$window.langs[a]});
    })

    settings.save_lang = function(){
        if(settings.current_lang)
        {
        $translate.use(settings.current_lang);
        service_mcache.set("_APP_DEFAULT_LANGUAGE",settings.current_lang);
        }
    }
     
    
    settings.is_premium = 0;
    settings.is_persuader = 0;
    settings.notification_sound = true;
    settings.notification_for_offers = true;
    settings.notification_for_messages = true;
    settings.notification_show_message_text = true;
    

    settings.save = function(){
        service_user.update({notification_sound:settings.notification_sound, notification_for_offers:settings.notification_for_offers, notification_for_messages: settings.notification_for_messages, notification_show_message_text: settings.notification_show_message_text });
    }

    settings.share = function(){

        service_share.share();
    }

     $scope.$on('$ionicView.enter', function () {
        var user = service_user.getUser();

        settings.notification_sound = user.notification_sound > 0 ? true : false;
        settings.notification_for_offers = user.notification_for_offers > 0 ? true : false;
        settings.notification_for_messages = user.notification_for_messages > 0 ? true : false;
        settings.notification_show_message_text = user.notification_show_message_text > 0 ? true : false;
        settings.is_premium = user.is_premium;
        settings.is_persuader = user.is_persuader;

            
     });



        $scope.$on('$ionicView.beforeEnter', function (event, viewData) { 
            viewData.enableBack = true;
        });
        $rootScope.$ionicGoBack = function() {
            $ionicHistory.goBack() || $state.go("app.search");
        };
    

     $scope.settings = settings;
});