angular.module('starter.controllers')

.controller('userCtrl', function($rootScope, $scope, $state, $stateParams, $timeout, $window, $ionicHistory, $ionicPlatform, $filter, $ionicLoading, $ionicPopup, service_search, service_mcache, service_gmap, service_user, _SERVER_SETTINGS){

	 var user = {};

     user.user_id = $stateParams.user_id;

     user.cdn = _SERVER_SETTINGS.image_cdn_url;
     user.info = {};
     user.get_profile = function(){

        $ionicLoading.show();
        service_search.get_user(user.user_id)
        .then(function(res){

            if(res.error == 0)
            {
                res.data.user.distance_km = service_gmap.distance(service_mcache.get('_CURRENT_LOCATION')||{lat: res.data.user.latitude, lng: res.data.user.longitude},{lat: res.data.user.latitude, lng: res.data.user.longitude});
                res.data.user.distance_text = $filter('translate')('AboutXkmAway').replace('XX',res.data.user.distance_km);
                user.info = res.data;
                ///console.warn(JSON.stringify(user.info))
            }

            $ionicLoading.hide();

        },function() {
            $ionicLoading.hide();
        })
     };

     user.start_chat = function(user_id){
        // mesajlaşma açılacak
        
     }

     user.report_abuse = function(user_id)
     {
         service_user.report_abuse(user_id);
         var alertPopup = $ionicPopup.alert({
                
                template: '<i class="ion-ios-checkmark balanced">',
                cssClass: 'successPopup',
            });
			service_mcache.remove("_SEARCH_PAGE_STATE");
            $timeout(function() {
                alertPopup.close(); //close the popup after 3 seconds for some reason
                $state.go("app.search",{});
            }, 2000);
     }

     user.add_agree = function(offer_id,is_persuade){
        service_search.add_agree(offer_id, is_persuade)
                .then(function(res){
                    if(res.error == 0)
                    {
                        // ok lendi, burada bi efekt şart 
                        if(is_persuade == 1)
                        {
                            service_search.push_persuade(offer_id);
                        }
                        else
                        {
                            service_search.push_agree(offer_id);
                        }
                         
                    }
                    else
                    {
                        var template = '';
                        switch(res.message)
                        {
                            default:
                            break;
                            case 'daily_agree_limit_reached':
                                template = $filter('translate')('daily_agree_limit_reached');
                            break;
                            case 'daily_persuade_limit_reached':
                                template = $filter('translate')('daily_persuade_limit_reached');
                            break;
                        }
                        if(template != '')
                        {
                            var alertPopup = $ionicPopup.alert({
                                title: $filter('translate')('Error'),
                                template: template,
                                okType: 'button-calm',
                                cssClass: 'text-center bigPopup'
                            });

                            alertPopup.then(function(res) {
                                $state.go("app.vip");
                            });
                        }
                    }
                },function(){

                })
     };
    
   /* $scope.$on("$ionicSlides.sliderInitialized", function(event, data){
         // data.slider is the instance of Swiper
        $scope.slider = data.slider;
    });

    $scope.$on("$ionicSlides.slideChangeStart", function(event, data){
        console.log('Slide change is beginning');
    });

    $scope.$on("$ionicSlides.slideChangeEnd", function(event, data){
        // note: the indexes are 0-based
        $scope.activeIndex = data.slider.activeIndex;
        $scope.previousIndex = data.slider.previousIndex;
    });
    */
    
    

    $scope.$on("$ionicView.enter", function(){
        $timeout(function(){
        user.get_profile();
        });
    });

    $ionicPlatform.onHardwareBackButton(function(event) {
        event.preventDefault();
        event.stopPropagation();
       // alert('going back now yall');
    });



     $scope.user = user;

        /*
        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
 
            viewData.enableBack = true;
        });*/
        $rootScope.$ionicGoBack = function() {
            $ionicHistory.goBack() || $state.go("app.search");
        };
});