angular.module('starter.controllers')

.controller('vipCtrl', function($rootScope, $scope, $state, $filter, $window, $timeout, $ionicHistory, $ionicPopup, $ionicLoading, service_inapppurchase, service_user, _APP_SETTINGS){

	 var vip = {};

     vip.get_loaded_product = function(id){

        var found = false;
        vip.all_products.forEach(function(p){

           
            if(p.productId == id)
            {
                 p.price_float = (p.price.replace(/\D/g,'')/100);
                 p.formatted_currency = p.price.replace(/\d/g,'').replace(",",'').replace(".",'');
                 found = p;

                return p;
            }
        });
        if(!found)
        {
            var m = {price:"$"+_APP_SETTINGS.default_subscription_prices[id],formatted_currency:'$', monthly_price:_APP_SETTINGS.default_subscription_prices[id], price_float:_APP_SETTINGS.default_subscription_prices[id] };
            return m;
        }
        else
        return found;

     };

     vip.show_package_group = function(type){

        var packs = [], prod_index1, prod_index2;
        
         if(type == 'vip')
         {
             packs.push(_APP_SETTINGS.in_app_purchase_products[0]);
             packs.push(_APP_SETTINGS.in_app_purchase_products[1]);
             prod_index1 = 0;
             prod_index2 = 1;
         }
         else if(type == 'per'){
            packs.push(_APP_SETTINGS.in_app_purchase_products[2]);
            packs.push(_APP_SETTINGS.in_app_purchase_products[3]);
            prod_index1= 2;
            prod_index2= 3;
         }

        var m1 = vip.get_loaded_product(packs[0]), m2 = vip.get_loaded_product(packs[1]);
         
        // console.warn(JSON.stringify(packs));
          //console.warn(JSON.stringify(m2));

        var template = '';
        template +=  '<h4>'+(type == 'vip' ? $filter('translate')('BuyOffrVip') : $filter('translate')('BuyPersuadePower'))+'</h4>';
        template +='<p>'+$filter('translate')('ChooseDuration')+'</p>';
        template +='<div class="row bigSqWrapper"><div class="col col-bottom">';

        template += '<a class="bigSqButton" ng-click="vip.buy('+prod_index1+');">';
        template += '<span class="bb_title">'+$filter('translate')('NoDiscount')+'</span>';
        template += '<span class="bb_h2">1</span>';
        template += '<span class="bb_h3">'+$filter('translate')('Month')+'</span>';
        template += '<span class="bb_p">'+m1.price+'/'+$filter('translate')('Month')+'</span>';
        template += '<span class="bb_b">'+$filter('translate')('Continue')+'</span>';
        template += '</a>';

        template += '</div><div class="col col-bottom">';

        template += '<a class="bigSqButton selected" ng-click="vip.buy('+prod_index2+');">';
        template += '<span class="bb_title">'+$filter('translate')('Discount')+' %'+Math.abs(Math.round((1 - (m2.price_float/(m1.price_float*6)))*100))+'</span>';
        template += '<span class="bb_h2">6</span>';
        template += '<span class="bb_h3">'+$filter('translate')('Month')+'</span>';
        template += '<span class="bb_p">'+m2.formatted_currency+''+(Math.floor(m2.price_float/6)-0.01)+'/'+$filter('translate')('Month')+'</span>';
        template += '<span class="bb_b">'+$filter('translate')('Continue')+'</span>';
        template += '</a>';

        template += '</div></div>';
        


       vip.buy_popup = $ionicPopup.show({
                template: template ,
               // title: type == 'vip' ? $filter('translate')('BuyOffrVip') : $filter('translate')('BuyPersuadePower'),
                //subTitle:  $filter('translate')('ChooseDuration'), 
                scope: $scope,
                cssClass:'bigPopup veryBigPopup text-center hide_pop_buttons hide_pop_head',
                /*buttons: [
                    { text: $filter('translate')('Cancel'),
                        type: 'button-small',
                    },
                    {
                        text: $filter('translate')('ChooseMonthly'),
                        type: 'button-calm button-small',
                        onTap: function(e) { 
                            e.preventDefault();
                            vip.buy(prod_index1);
                        }
                    },
                     {
                        text: $filter('translate')('Choose6Monthly'),
                        type: 'button-royal',
                        onTap: function(e) { 
                            e.preventDefault();
                            vip.buy(prod_index2);
                        }
                    }
                ]*/
            });
        
     };
     
     vip.buy = function(selected_product_index){

        var selected_product_id = _APP_SETTINGS.in_app_purchase_products[selected_product_index];

        service_inapppurchase.subscribe(selected_product_id)
		.then(function(){
			//console.log("service_inapppurchase.subscribe");
			service_user.refresh();
			 
			var alertPopup = $ionicPopup.alert({
			 title: $filter('translate')('PurhcaseSusccessfull'),
			 template: '<p class="text-center">'+$filter('translate')('PurchaseSuccessText')+'</p>',
             okType:'button-calm',
             cssClass:'text-center',
		    });

		   alertPopup.then(function(res) {
				//$window.location.reload(true);
                vip.buy_popup.close();
		   });
			
		},function(err,mes){
			//console.warn("buy err"+JSON.stringify(err));
			//console.warn("buy err mes"+JSON.stringify(mes));
			//$window.location.reload(true);
		});

     }

     vip.first_load_busy = false;
	 vip.first_load = function(){
		
		if(vip.first_load_busy == true) return;
		vip.first_load_busy = true;
		$ionicLoading.show();
		
	
	 
		service_inapppurchase.loadProducts()
		.then(function(prod){
			console.warn("products "+JSON.stringify(prod));
			
			for(var pindex in prod)
			{
				var the_product =  prod[pindex];
                if(the_product.price)
                {
                    var price = prod[pindex].price.replace(/[^\d.\.,]/g,'').replace(",",'.');
                    var currency = prod[pindex].price.replace(/[\d.\.,]/g,'');
                   // console.warn("price "+JSON.stringify(price));
                    prod[pindex].daily_price = Math.floor(price * 100 / 30)/100;
                    prod[pindex].monthly_price = prod[pindex].daily_price * 30;
                    prod[pindex].formatted_currency = currency;
                }
                 
			}
            
            vip.all_products = prod;
			vip.first_load_busy = false;  
			
            $ionicLoading.hide();
			
		},function(){
			vip.first_load_busy = false;
		});
		
		
	};
	
	
	$timeout(function(){
		
		vip.first_load();
		
	},1000);
    


     $scope.vip = vip;


        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
 
            viewData.enableBack = true;
        });
        $rootScope.$ionicGoBack = function() {
            $ionicHistory.goBack() || $state.go("app.search");
        };
});