angular.module('starter.controllers')

.controller('visitorsCtrl', function($rootScope, $scope, $state, $stateParams, $window, $ionicHistory, $ionicLoading, $filter, $timeout, $ionicPopup, service_timelabel, service_mcache, service_user, service_gmap, _SERVER_SETTINGS ){

    var visitor = {};


    visitor.cdn = _SERVER_SETTINGS.image_cdn_url;
    visitor.distance = function(ulat, ulng){
        var cl =service_mcache.get("_CURRENT_LOCATION") || {lat:ulat, lng:ulng };
           return service_gmap.distance(cl, {lat:ulat, lng:ulng});
    };

    


    visitor.show_user = function(user_id){
        var is_premium = service_user.isPremium();
        if(is_premium)
        {
            $state.go("app.user",{user_id:user_id});
        }
        else{
            var alertPopup = $ionicPopup.alert({
                title: $filter('translate')('OnlyVIP'),
                template: $filter('translate')('OnlyVIPUsersCanShowVisitorProfile'),
                okType:'button-calm',
                cssClass:'text-center'
            });

            alertPopup.then(function(res) {
                $state.go("app.vip");
            });
        }
    }

    visitor.limit = 10;
    visitor.list = [];
    visitor.page = 1;
    visitor.can_load_more = false;
    visitor.timeago = service_timelabel.timeago;

    visitor.get_all = function(force){
        if(force)
        {
            visitor.list = [];
            visitor.page = 1;
            visitor.can_load_more = false;
        }
        service_user.get_visitors(visitor.page)
        .then(function(res){

            if(res.error == 0)
            {
                res.data.visitors.forEach(function(v){
                    visitor.list.push(v);
                });

                if(res.data.visitors.length > 0 )
                {
                    visitor.can_load_more = true;
                }
                else
                {
                    visitor.can_load_more = false;
                }
            }

        },function(){

        });

    }

    visitor.load_more = function(){
        visitor.page++;
        visitor.get_all();
    }
    
    
    $scope.$on("$ionicView.enter",function(){
        $timeout(function(){
            
            visitor.get_all();
        });
    });

    $scope.$on('$ionicView.beforeEnter', function (event, viewData) { 
            viewData.enableBack = true;
        });
        $rootScope.$ionicGoBack = function() {
            $ionicHistory.goBack() || $state.go("app.search");
        };

    $scope.visitor = visitor;
});