/* by ertan 14:33 12.04.2016*/
'use strict';
angular.module('starter.services')
.factory('service_api', function ($q, $rootScope, $http, $ionicPopup, $filter, $window,  $translate, service_localstorage, service_mcache, $cordovaNetwork, $cordovaToast,  _APP_SETTINGS, _SERVER_SETTINGS){
 
	
	var http = {};
    if(_SERVER_SETTINGS.mode == 'development')
    var api_url = _SERVER_SETTINGS.develop_api_url + "?std_auth_key="+ _SERVER_SETTINGS.std_auth_key + "&params_format=json";
    else
    var api_url = _SERVER_SETTINGS.api_url + "?std_auth_key="+ _SERVER_SETTINGS.std_auth_key + "&params_format=json";
	
	 
	
	http.isOnline = function(cmd)
	{
		
		var is_on =  $cordovaNetwork.isOnline();
		if(!is_on)
		{
			 
				$cordovaToast.showShortCenter($filter('translate')('NoInternetConnection'));
			 
			//alert(cmd);
			$rootScope.$broadcast('scroll.refreshComplete');
			$rootScope.$broadcast('scroll.infiniteScrollComplete');
		}
		return is_on;
	};
	
	http.get = function(command,params,current_user)
	{
		if(!params) params = {};
		//console.warn("http.get command"+command);
		var defer = $q.defer();
		
		if(http.isOnline(command))
		{
			if(current_user)
			{
				var cuser = service_mcache.get(_APP_SETTINGS.user_cookie_name);
				if(cuser)
				{
				params.user_id = cuser.user_id;
				params.access_token = cuser.access_token;
				}
				else
				{
					//console.error("CURRENT_USER UNDEFINED!");	
				}	
			}
			
			params.version = _APP_SETTINGS.version;
			
			params.device_type = _APP_SETTINGS.device_type;
			params.app_id = _APP_SETTINGS.server_app_id;
			
			var device_id = service_mcache.get(_APP_SETTINGS.gcm_key_name);
			if(device_id)
			params.device_id = device_id;
			
			 
			params.language_code = $translate.use();
			
			params.country_code = service_mcache.get("_DEVICE_COUNTRY_CODE");
			
			var unique_device_hash = service_mcache.get("_DEVICE_UUID");
			if(unique_device_hash != false && unique_device_hash != '')
			{
				params.unique_device_hash = unique_device_hash ;
			}
			
			var current_location = service_mcache.get('_CURRENT_LOCATION');
			if(current_location)
			{
				if(!params.latitude && !params.longitude)
				{
					params.latitude = current_location.lat;
					params.longitude = current_location.lng;
				}
			}
			
			
			var uri = api_url+"&rquest=get&command="+command+"&params="+encodeURI(JSON.stringify(params));
			//console.log(uri);
			
			$http.get(uri)
			.then(function(res){
				//console.log("resresres");
				//console.log("service_api:get "+JSON.stringify(res));
				defer.resolve(res.data);
			},function(err,status, headers, config){
			//	console.log("$http.get rejected");
				//console.error("$http.get rejected "+JSON.stringify(err));
				 
				if(err.status == 0)
				{
					/*var alertPopup = $ionicPopup.alert({
					 title: $filter('translate')('Error'),
					 template: $filter('translate')('NoInternetConnection')
				   });*/
				}
				defer.reject();
			});
		}
		else
		defer.reject();
		return defer.promise;
	};
	
	http.post = function(command,params,current_user)
	{
		
		var defer = $q.defer();
		if(!params) params = {};
		
		
		if(http.isOnline(command))
		{
			
			var uri = api_url+"&rquest=post&command="+command;
			 
				
			if(current_user)
			{
				var cuser = service_mcache.get(_APP_SETTINGS.user_cookie_name);
				if(cuser)
				{
					params.user_id = cuser.user_id;
					params.access_token = cuser.access_token;
				}
				else
				{
					//console.error("CURRENT_USER UNDEFINED!");	
				}
			}
				
			 
			
			params.version = _APP_SETTINGS.version;

			params.device_type = _APP_SETTINGS.device_type;
			params.app_id =  _APP_SETTINGS.server_app_id;
			
			var device_id = service_mcache.get(_APP_SETTINGS.gcm_key_name);
			if(device_id)
			params.device_id = device_id;
			
			params.language_code = $translate.use();
			
			params.country_code = service_mcache.get("_DEVICE_COUNTRY_CODE");
			
			/*var Object = new Object();
			Object.toparams = function ObjecttoParams(obj) 
			{
			  var p = [];
			  for (var key in obj) 
			  {
				p.push(key + '=' + encodeURIComponent(obj[key]));
			  }
			  return p.join('&');
			};*/
			
			//console.log("$http.post "+JSON.stringify(req));
			var unique_device_hash = service_mcache.get("_DEVICE_UUID");
			if(unique_device_hash != false && unique_device_hash != '')
			{
				params.unique_device_hash = unique_device_hash ;
			}

			var current_location = service_mcache.get('_CURRENT_LOCATION');
			if(current_location)
			{
				if(!params.latitude && !params.longitude)
				{
					params.latitude = current_location.lat;
					params.longitude = current_location.lng;
				}
			}
			
			//console.log("$http.post unique_device_hash"+JSON.stringify(unique_device_hash));
			 var req = 
			{
				method: 'POST',
				url: uri,
				data: "params="+encodeURI(JSON.stringify(params)), //Object.toparams(params),
				headers: {'Content-Type': 'application/x-www-form-urlencoded'}
			};
			//console.log("$http.post "+JSON.stringify(req));
			//$http.post(uri, {params:params} )
			$http(req)
			.success(function(res){
				//console.log("resresres"+JSON.stringify(res));
				//console.log(res);
				defer.resolve(res);
			}).error(function(res, status, headers, config){
				console.log("$http.post rejected "+JSON.stringify(res));
				console.log("$http.post rejected "+JSON.stringify(status));
				console.log("$http.post rejected "+JSON.stringify(headers));
				console.log("$http.post rejected "+JSON.stringify(config));
				 
				defer.reject();
			});
		}
		else
		defer.reject("not-online");
		
		return defer.promise;
	};
	
	http.get_upload_url = function(command,params,encode)
	{	
		var current_user = service_mcache.get(_APP_SETTINGS.user_cookie_name);
			params.user_id = current_user.user_id;
			params.access_token = current_user.access_token;
			var unique_device_hash = service_mcache.get("_DEVICE_UUID");
			if(unique_device_hash != false && unique_device_hash != '')
			{
				params.unique_device_hash = unique_device_hash ;
			}
			params.device_type = _APP_SETTINGS.device_type;
			params.app_id =  _APP_SETTINGS.server_app_id;
			params.language_code = $translate.use();
			params.version = _APP_SETTINGS.version;
			
			params.country_code = service_mcache.get("_DEVICE_COUNTRY_CODE");
			
			var device_id = service_mcache.get(_APP_SETTINGS.gcm_key_name);
			if(device_id)
			params.device_id = device_id;
			var current_location = service_mcache.get('_CURRENT_LOCATION');
			if(current_location)
			{
				if(!params.latitude && !params.longitude)
				{
					params.latitude = current_location.lat;
					params.longitude = current_location.lng;
				}
			}
			
		return api_url +"&rquest=post&command="+command+"&params="+ ( encode ? encodeURI(JSON.stringify(params)) : JSON.stringify(params));
	};
   
   
   return http;
 
});