angular.module('starter.services')

.factory('service_geo',  function($q, $timeout, $window, $cordovaGeolocation, $ionicPlatform, $ionicPopup, $filter, service_mcache,service_user)
{
	
	var geo = {};
	
	var posOptions = {timeout: 10000, enableHighAccuracy: true ,maximumAge:1000};
	
	
    
		
		geo.get = function()
		{
			var defer = $q.defer();
			
				 
				
				var pos = $cordovaGeolocation.getCurrentPosition(posOptions)
				.then(function (position){
					var lat  = position.coords.latitude
					var lng = position.coords.longitude 
					service_mcache.set("_CURRENT_LOCATION",{lat:lat,lng:lng});
					service_user.update({latitude:lat, longitude:lng});
					defer.resolve( {lat:lat,lng:lng});
				},
				function(err){
					//console.error("!!!!!!!!!!!!!!!!!!!!!!!!!!!err"+JSON.stringify(err));
					//alert("err"+JSON.stringify(err));
					defer.reject( {err:err});
					
				});
			 
			
			return defer.promise;
		};
		
		geo.is_available = function()
		{
			var defer = $q.defer();
			$ionicPlatform.ready(function(){
				cordova.plugins.diagnostic.isLocationEnabled(function(res){
					//console.error(res);
					if(!res) 
					{
						 
						  	var alertPopup = $ionicPopup.alert({
									title: $filter('translate')('LocationNeeded'),
									okType:'button-calm',
									cssClass:'text-center',
									template: $filter('translate')('LocationNeededOpenSettings')
							});

							alertPopup.then(function(){
								$window.onResumeEvents.push(function(){
									geo.is_available();
									
								});
								geo.open_settings();
								defer.reject();
							});	
					}
					else
					{
						cordova.plugins.diagnostic.isLocationAuthorized(function(res2){
							//console.error("$cordovaDiagnostic.isLocationAuthorized",JSON.stringify(res));
							if(res2)
							{
								 
								defer.resolve(res2);
							}
							else
							{ 
									cordova.plugins.diagnostic.requestLocationAuthorization(function(status){
										//console.error("$cordovaDiagnostic.requestLocationAuthorization()"+JSON.stringify(status));

											cordova.plugins.diagnostic.isLocationAuthorized(function(res3){
												defer.resolve(res3);
											},function(err){
												//console.error("$cordovaDiagnostic.isLocationAuthorized err",JSON.stringify(err));
												defer.reject();
											});
										
									},function(){
										defer.reject();
									}); 
							}
						},function(err){
							//console.error("$cordovaDiagnostic.isLocationAuthorized err",JSON.stringify(err));
							defer.reject();
						})
						 
					}
					
				},function(){
					
					defer.reject();
				});
				 
			});
			return defer.promise;
		};
		
		geo.open_settings = function()
		{
			var q = $q.defer();
			
				cordova.plugins.diagnostic.switchToLocationSettings();
				q.resolve();
			
			return q.promise;
		};
     
	 
     
	return geo;
});