angular.module('starter.services')

.factory('service_localstorage', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function(key, value) {
	  var timestamp = new Date().getTime();
	  value.lsTimeStamp = Math.floor(timestamp/1000);
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function(key) {
      return JSON.parse($window.localStorage[key] || '{}');
    },
    remove:  function(key)
    {
		$window.localStorage.removeItem(key);
		return true;
    },
    getAll: function(regex){
		var keys = Object.keys($window.localStorage);
		var search = [];
		regex = new RegExp(regex);
		 
		for( var i in keys)
		{
			if(regex.test(keys[i]+"i"))
			search.push(keys[i]);
		}
		return search;
    },
    removeAll: function()
    {
		var keys = Object.keys($window.localStorage);
		for(var i in keys)
		{
			$window.localStorage.removeItem(keys[i]);
		}
    }
    
  }
}]);