angular.module('starter.services')
.factory('service_login', function($q, service_api, service_mcache, service_localstorage, _APP_SETTINGS){
  
	var login = {};
	
	login.lostpw = function(email)
	{
		var defer = $q.defer();
		 
		service_api.get("app.user.lostpw",{email:email})
		.then(function(res){
			 
			defer.resolve(res); 
			
		},function(){
			defer.reject();
		});
		
		return defer.promise;
	};

	login.signin = function(email,password)
	{
		var defer = $q.defer();
		var device_id = service_mcache.get(_APP_SETTINGS.gcm_key_name);
		service_api.get("app.user.login",{email:email,password:password,device_id:device_id})
		.then(function(res){
			
			if(res.error  == 0)
			{
				service_mcache.set(_APP_SETTINGS.user_cookie_name, res.data, _APP_SETTINGS.cache_max_age);
				defer.resolve();
			}
			else
			{
				defer.reject();
			}
			
		},function(){
			defer.reject();
		});
		
		return defer.promise;
	};
	login.signout = function()
	{
		service_mcache.removeAll();
		service_localstorage.removeAll();
		
	};
	login.register = function(email,password)
	{
		var defer = $q.defer();
		var device_id = service_mcache.get(_APP_SETTINGS.gcm_key_name);
		service_api.get("app.user.register",{email:email,password:password,device_id:device_id})
		.then(function(res){
			//console.log("res reg" +JSON.stringify(res));
			if(res.error  == 0)
			{
				service_mcache.set(_APP_SETTINGS.user_cookie_name, res.data, _APP_SETTINGS.cache_max_age);
				defer.resolve();
			}
			else
			{
				defer.reject(res.message);
			}
			
		},function(){
			defer.reject();
		});
		
		return defer.promise;
	};
	
	login.check = function()
	{
		var the_user = service_mcache.get(_APP_SETTINGS.user_cookie_name);
		if(!the_user)
		return false;
		else
		{
			var device_id = service_mcache.get(_APP_SETTINGS.gcm_key_name);
			if(device_id)
			{
				service_api.get("app.user.update",{device_id:device_id },true)
				.then(function(e){
					//console.log("eeeeeeeeeee "+JSON.stringify(e));
				},function(){
				});
			}
			return true;
		}
	};

	return login;
});