angular.module('starter.services')

.factory('service_search',  function($q,  service_api, service_mcache, _APP_SETTINGS)
{

    var search = {};

    search.get_user = function(target_user_id){
        var defer = $q.defer();

        service_api.get("app.search.profile",{target_user_id:target_user_id}, true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        })

        
        return defer.promise;
    }
    
    search.guess_offer = function(query){
        var defer = $q.defer();

        service_api.get("app.search.guess",{query:query}, true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        });


        return defer.promise;
    }

    search.save_offer = function(data){
        var defer = $q.defer();

        service_api.get("app.user.save_offer",data, true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        })

        
        return defer.promise;
    }

    search.get_agrees = function(page){
        var defer = $q.defer();

        service_api.get("app.user.get_offer_agrees",{page: page}, true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        })

        
        return defer.promise;
    };

    search.search = function(terms){
        var defer = $q.defer();

        service_api.get("app.search.search",terms, true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        });

        return defer.promise;
    };

    search.get_offer = function(){
        var defer = $q.defer();

        service_api.get("app.user.get_offer",{}, true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        });

        return defer.promise;
    };

    search.add_agree = function(offer_id, is_persuade){
        var defer = $q.defer();

        service_api.get("app.search.agree",{offer_id:offer_id, is_persuade:is_persuade}, true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        });

        return defer.promise;
    };

    search.push_agree = function(offer_id){
                search.agrees_list = service_mcache.get("_AGREES_LIST") || [];
        search.agrees_list.push(offer_id);
        if(search.agrees_list.length > _APP_SETTINGS.max_agree_keep_count)
        {
            search.agrees_list.splice(0,1);
        }
        service_mcache.set("_AGREES_LIST",search.agrees_list);
        return search.agrees_list;
    }

    search.get_agreed_list = function(){
        return service_mcache.get("_AGREES_LIST")||[];
    };
    
     
    search.push_persuade = function(offer_id){
                search.persuades_list = service_mcache.get("_PERSUADES_LIST") || [];
        search.persuades_list.push(offer_id);
        if(search.persuades_list.length > _APP_SETTINGS.max_agree_keep_count)
        {
            search.persuades_list.splice(0,1);
        }
        service_mcache.set("_PERSUADES_LIST",search.persuades_list);
        return search.persuades_list;
    }
    search.get_persuaded_list = function(){
        return service_mcache.get("_PERSUADES_LIST")||[];
    };

    search.clear_action_lists = function(){
        service_mcache.remove("_AGREES_LIST");
        service_mcache.remove("_PERSUADES_LIST");
    }

    

    return search;
});