'use strict;'
angular.module('starter.services')
.factory('service_timelabel', function ($q, $filter) {
 
   var now = new Date();
   var label = {};
   
   label.is_between = function(start, end)
   {
	 var now = new Date();
	 var nhour = now.getHours();
	 var nmin = now.getMinutes();
	 
	 var shour = parseInt(start.split(":")[0]);
	 var smin = parseInt(start.split(":")[1]);
	 
	 var ehour = parseInt(end.split(":")[0]);
	 var emin = parseInt(end.split(":")[1]);
	 
	 
	 if(emin == 0) emin = 60; 
	 
	 
	 
	 if(nhour >= shour && nmin >= smin && nhour <= ehour && nmin <= emin)
	 {
		return true;
	 }
	 else
	 return false;
   };
   label.clock = function(time)
   {
		return time.split(":")[0]+":"+time.split(":")[1];
   };
   label.timeago = function(secs_passed)
   {
	//console.log("secs_passed"+secs_passed);	
		var pad = "00";
		
		var time = (now.getTime()/1000);
		var passed_time = time - new Date( (time- secs_passed) *1000).getTime()/1000;
		secs_passed = passed_time;
		var res = "";
		if(secs_passed < 60)
		{
			res =  $filter('translate')('seconds_ago');
		}
		else
		{
			if(secs_passed < 3600)
			{
				
				res =  Math.floor(secs_passed/60)+" "+ $filter('translate')('minutes_ago');
			}
			else
			{
				
				
				/*time = (time- secs_passed);
				var past = new Date(time*1000), past_time = (pad.substring(0, pad.length - past.getHours().toString().length) + past.getHours() )+":"+ pad.substring(0, pad.length - past.getMinutes().toString().length) + past.getMinutes();
				
				if(now.getUTCDate() != past.getUTCDate())
				res = past.getUTCDate()+" "+$filter('translate')('months.'+past.getUTCMonth())+" "+ past_time;
				else
				res = past_time +" "+ $filter('translate')('at_time');*/
				if(secs_passed < 86400)
				res =  Math.floor(secs_passed/3600)+" "+ $filter('translate')('hours_ago');
				else
				{
					res =  Math.floor(secs_passed/86400)+" "+ $filter('translate')('days_ago');
				}
			}
		}
		
		 
		 
		 
		return  res;
   };
   label.passed_time = function(secs,add)
   {
		secs = parseInt(secs);
		secs += parseInt(add);
		//console.log("secs"+secs);
		var res;
		 if(secs < 60)
		 res = "00:00:"+label.pad(secs);
		 else
		 {
			if(secs < 3600)
			{
				var mins = Math.floor(secs/60);
				var new_secs = secs - (mins * 60);
				res = "00:"+label.pad(mins)+":"+label.pad(new_secs);
			}
			else
			{
				if(secs < 86400)
				{
					var hours = Math.floor(secs/3600);
					var mins = Math.floor((secs - (hours*3600))/60);
					var new_secs = secs - (mins * 60 + hours* 3600);
					res = label.pad(hours)+":"+label.pad(mins)+":"+label.pad(new_secs);
				}
				else
				{
					var days = Math.floor(secs/86400);
					var hours = Math.floor((secs- (days * 86400))/3600);
					var mins = Math.floor((secs - (days * 86400 + hours*3600))/60);
					var new_secs = secs -( days * 86400 + hours*3600 +mins * 60);
					res = days+" "+$filter('translate')('days')+" "+label.pad(hours)+":"+label.pad(mins)+":"+label.pad(new_secs);
				}
			}
		 }
			 
	
		return res;
   };
   label.shorten_number = function(number)
   {
		 
		var res = ""+number;
		if(number > 1000 && number < 1000000)
		{
			res = (Math.floor(number/100)/10) + "k";
		}
		else if(number >= 1000000 && number < 1000000000)
		{
			res = (Math.floor(number/100000)/10) + "Mn";
		}
		
		return res;
   };
   
   label.gettime =function(date)
   {
		var the_date = new Date(date);
		
		return  label.pad(the_date.getHours())+":"+label.pad(the_date.getMinutes());
   };
   
   label.getdate =function(date, str)
   {
		var the_date = new Date(date);
		
		if(!str)
		return  [label.pad(the_date.getUTCDate()), ($filter('translate')("months."+the_date.getUTCMonth())), the_date.getUTCFullYear()];
		else
		return  label.pad(the_date.getUTCDate()) +" "+($filter('translate')("months."+the_date.getUTCMonth()))+" "+ the_date.getUTCFullYear();
   };
   
   label.pad = function(str)
   {
		str += "";
		var pad = "00";
		var ans = pad.substring(0, pad.length - str.length) + str;
		return ans;
   };
   
    return label;
 
});