/* by ertan 14:33 12.04.2016*/
'use strict';
angular.module('starter.services')
.factory('service_upload', function ($q, $cordovaCamera, $cordovaFileTransfer, service_api, _APP_SETTINGS){
 
    
    var upload = {};
    
    /*photos*/
    var photo = {};
		photo.photo_uri = "";
		photo.take_photo = function(){
			var defer = $q.defer();
			
			var options = {
                    quality: _APP_SETTINGS.camera_options.quality || 90,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: Camera.PictureSourceType.CAMERA,
                    allowEdit: true,
                    encodingType: Camera.EncodingType.JPEG,
                    targetWidth: _APP_SETTINGS.camera_options.width || 480,
                    targetHeight: _APP_SETTINGS.camera_options.height || 480,
                    popoverOptions: {},//new CameraPopoverOptions(300, 300, 200, 200, Camera.PopoverArrowDirection.ARROW_ANY),
                    saveToPhotoAlbum: false,
                    correctOrientation: true
                   }
			
			 photo.getDevicePicture(options)
			 .then(function(res){
				defer.resolve(res);
			 },function(){
				defer.reject()
			 });
			 
			return defer.promise;		
		};
		
		photo.choose_photo = function () {
			var defer = $q.defer();
                  var options = {
                    quality: _APP_SETTINGS.camera_options.quality || 90,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                    //allowEdit: false, // galeriden se�me modunda kesim olmuyor
                    encodingType: Camera.EncodingType.JPEG,
                    targetWidth: _APP_SETTINGS.camera_options.width || 480,
                    targetHeight: _APP_SETTINGS.camera_options.height || 480,
                  //  popoverOptions: {},
                    saveToPhotoAlbum: false,
                    correctOrientation: true
                     
					};
   
				  photo.getDevicePicture(options)
				  .then(function(res){
					defer.resolve(res);
				 },function(){
					defer.reject()
				 });
					 
			return defer.promise;		
        };
                
        photo.getDevicePicture = function(options)
		{
			var defer = $q.defer();
			$cordovaCamera.getPicture(options).then(function (res) {
			  
			   console.warn("sourceUri: "+JSON.stringify(res));
				 photo.photo_uri = res;
				defer.resolve(res);
			   
			}, function (err) {
				// An error occured. Show a message to the user
				defer.reject();
			});
			return defer.promise;
		};      
    /*photos*/
 
	upload.take_photo = photo.take_photo;
	upload.choose_photo = photo.choose_photo;
	
	
	upload.save = function(targetPath, command,params)
	{
		var defer = $q.defer();
		
			if(!command) command = "app.common.uploader";
			if(!params) params = {};
			if(!targetPath)
			targetPath = photo.photo_uri; //"img/imgres.jpg"; //photo.photo_uri // file:///storage/emulated/0/Android/data/com.cetabilisim.orions/cache/20160415_191527.jpg
	 
			if(targetPath)
			{
				var filename = targetPath.split("/").pop();
				 
				var options = {
					 fileKey: "posted_image",
					 fileName: filename,
					 chunkedMode: false,
					 mimeType: "image/jpg",
					 params : params
				 };
				 
				var url = service_api.get_upload_url(command,params,false);	  
				 $cordovaFileTransfer.upload(url, targetPath, options)
				 .then(function (result) {
					//console.log("resulst po" + JSON.stringify(result));
					result.response = JSON.parse(result.response);
					 console.log("SUCCESS: " + JSON.stringify(result.response));
					 defer.resolve(result.response);
					 
				 }, function (err) {
					 console.log("ERROR: " + JSON.stringify(err));
					 defer.reject();
				 }, function (progress) {
					 // PROGRESS HANDLING GOES HERE
				 });
				 
			} 
			 
		return defer.promise;
	};
	
	upload.save_multiple = function(images)
	{
		var defer = $q.defer();
		var proms = [];
		for( var i in images)
		{
			proms.push(upload.save(images[i]));
		}
		
		$q.all(proms)
			.then(function(r1){
				//console.warn("R1 !!!!!!!!!!!!!",JSON.stringify(r1));
				defer.resolve(r1);
			},function(e1){
				//console.error("E1 !!!!!!!!!!!!!",JSON.stringify(e1));
				defer.resolve({});
			});
		return defer.promise;
	};
		
 
	return upload;
});