'use strict';
angular.module('starter.services')
.factory('service_user', function ($q, $state, $window, $ionicLoading, $filter, $ionicPopup, $ionicBackdrop, service_localstorage, service_api, service_mcache, service_review, $translate, _APP_SETTINGS) {
 
   
  var ret = {

	  	check_version: function(){

			var defer = $q.defer();
			 service_api.get("app.common.check_version",{},true)
			 .then(function(res){
				
				if(res.error == 0)
				{

					if(res.data._FORCE_UPDATE == true)
					{
						var alertPopup = $ionicPopup.alert({
								title: $filter('translate')('Error'),
								template: $filter('translate')('YourAppOutdated'),
								okType: 'button-calm',
								cssClass: 'bigPopup text-center',
							});

							alertPopup.then(function() {
								service_review.redirect(res.data._APP_CURRENT_ID_GOOGLE);
								$window.onResumeEvents.push(function(){
									ret.check_version();
								});
							});
					}
				}


				defer.resolve(res);


			 },function(){
				defer.reject();
			 });
			
			 return defer.promise;

		},

		get_visitors: function(page, visitor_id){
			var defer = $q.defer();
			 service_api.get("app.user.get_visitors",{page:page, visitor_id: visitor_id},true)
			 .then(function(res){
			 
				defer.resolve(res);
			 },function(){
				defer.reject();
			 });
			
			 return defer.promise;
		},

		report_abuse: function(target_user_id){
			var defer = $q.defer();
			 service_api.get("app.user.report",{target_user_id:target_user_id},true)
			 .then(function(res){
			 
				defer.resolve(res);
			 },function(){
				defer.reject();
			 });
			
			 return defer.promise;
		},
  
		send_verify: function(tel,cc)
		{
			var defer = $q.defer();
			 service_api.get("app.verify.send",{telephone:tel, cc: cc},true)
			 .then(function(res){
			 
				defer.resolve(res);
			 },function(){
				defer.reject();
			 });
			
			 return defer.promise;
		},
		check_verify: function(verify_code)
		{
			var defer = $q.defer();
			 service_api.get("app.verify.verify",{verify_code:verify_code},true)
			 .then(function(res){
			 
				defer.resolve(res);
			 },function(){
				defer.reject();
			 });
			
			 return defer.promise;
		}, 
		latitude: function(){
			var sess = ret.check();
			if(sess) return sess.latitude || 0;
			return 0;
		},
		longitude: function(){
			var sess = ret.check();
			if(sess) return sess.longitude || 0;
			return 0;
		},
		 
		update: function (data) {
		
		  var defer = $q.defer();
		  
		  var user_id = ret.getUserId();
		  var access_token = ret.getAccessToken();
		  
		  if( !user_id || !access_token)
		  {
			defer.reject();
		  }
		  else
		  { 
				if(!data.language_code)
				data.language_code = $translate.use() || $window.preferredLanguage || $window._APP_DEFAULT_LANGUAGE || 'en';
				  
				service_api.get("app.user.update",data,true)
				.then(function(res){
					ret.refresh();
					defer.resolve();
			    },function(){
					defer.reject();
			    });
		  }
		 
		  return  defer.promise;
		},
		isPremium: function(){
			var sess = ret.check();
			if(sess) return parseInt(sess.is_premium) == 1;
			return false;
		},
		 
		
		getUserId : function(){
			
			var sess = ret.check();
			if(sess) return sess.user_id;
			return false;
		},
		 
		getUser: function(){
			var sess = ret.check();
			return sess;
		},
		
		getUserName : function(){
			
			var sess = ret.check();
			if(sess) return sess.name;
			return false;
		},
		getUserSurname : function(){
			
			var sess = ret.check();
			if(sess) return sess.surname;
			return false;
		},
		getUserUsername : function(){
			
			var sess = ret.check();
			if(sess) return sess.username;
			return false;
		},
		getUserEmail : function(){
			
			var sess = ret.check();
			if(sess) return sess.email;
			return false;
		},
		 
		getCountryCode : function(){
			
			var sess = ret.check();
			if(sess) return sess.country_code;
			return false;
		},
		 
		getAccessToken : function(){
			 
			var sess = service_mcache.get(_APP_SETTINGS.user_cookie_name);
			 
			if(sess)
			{
				return sess.access_token;
			}
			else
			{
				return false;
			}
		},
		refresh: function(){
			var defer = $q.defer();
				service_api.get("app.user.get",{},true)
				.then(function(res){
					if(res.error == 0)
					{
						 
						var data = {user_id: ret.getUserId(), access_token: ret.getAccessToken(), user: res.data};
						service_mcache.set(_APP_SETTINGS.user_cookie_name, data, _APP_SETTINGS.cache_max_age);
						defer.resolve();
					}
					else if(res && res.error == 1)
					{
						service_mcache.remove(_APP_SETTINGS.user_cookie_name);
						ret.register();
						defer.reject();
					}
					 
			    },function(){
					 defer.reject();
			    });
			return defer.promise;
		},
		check: function(){
			var sess = service_mcache.get(_APP_SETTINGS.user_cookie_name);
			 //console.log("sess "+ JSON.stringify(sess));
			 //service_mcache.remove(_APP_SETTINGS.user_cookie_name)
			if(sess)
			{
				return sess.user;
			}
			else
			{
				return false;
			}
		},
		
		register: function(){
			
			$ionicLoading.show();
			var defer = $q.defer();
			 
			var device_id = service_mcache.get(_APP_SETTINGS.gcm_key_name);
			var unique_device_hash = service_mcache.get('_DEVICE_UUID');
			
			service_api.get("app.user.register",{unique_device_hash: unique_device_hash,  device_id: device_id})
			.then(function(res){

				console.log("res register" +JSON.stringify(res));
				if(res.error  == 0)
				{	
					//console.log(JSON.stringify(res.data))
					service_mcache.set(_APP_SETTINGS.user_cookie_name, res.data, _APP_SETTINGS.cache_max_age);
					//$state.go($state.current, {}, {reload: true});
					$state.go("app.profile",{});
					defer.resolve();
					
				}
				else
				{
					defer.reject(res.message);
				}
				$ionicLoading.hide();
				
			},function(){
				defer.reject();
				$ionicLoading.hide();
			});
			 
			return defer.promise;
		},

		
		
    }
    
    return ret;
 
});